(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/common'), require('rxjs'), require('rxjs/operators')) :
    typeof define === 'function' && define.amd ? define('@dxgm/maps', ['exports', '@angular/core', '@angular/common', 'rxjs', 'rxjs/operators'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory((global.dxgm = global.dxgm || {}, global.dxgm.maps = {}), global.ng.core, global.ng.common, global.rxjs, global.rxjs.operators));
}(this, (function (exports, core, common, rxjs, operators) { 'use strict';

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/services/abstract/abstract-map-api-loader.service.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @abstract
     */
    var MapsAPILoader = /** @class */ (function () {
        function MapsAPILoader() {
        }
        return MapsAPILoader;
    }());
    MapsAPILoader.decorators = [
        { type: core.Injectable }
    ];
    if (false) {
        /**
         * @abstract
         * @return {?}
         */
        MapsAPILoader.prototype.load = function () { };
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/services/fitbounds.service.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var FitBoundsService = /** @class */ (function () {
        /**
         * @param {?} loader
         */
        function FitBoundsService(loader) {
            var _this = this;
            this.loader = loader;
            this._boundsChangeSampleTime$ = new rxjs.BehaviorSubject(200);
            this._includeInBounds$ = new rxjs.BehaviorSubject(new Map());
            this._fitBoundsDetails$ = new rxjs.ReplaySubject(1);
            this.bounds$ = rxjs.from(loader.load()).pipe(operators.mergeMap(( /**
             * @return {?}
             */function () { return _this._includeInBounds$; })), operators.sample(this._boundsChangeSampleTime$.pipe(operators.switchMap(( /**
             * @param {?} time
             * @return {?}
             */function (time) { return rxjs.timer(0, time); })))), operators.map(( /**
             * @param {?} includeInBounds
             * @return {?}
             */function (includeInBounds) { return _this.generateBounds(includeInBounds); })), operators.shareReplay(1));
        }
        /**
         * @return {?}
         */
        FitBoundsService.prototype.getFitBoundsDeta = function () {
            return this._fitBoundsDetails$.asObservable();
        };
        /**
         * @param {?} position
         * @return {?}
         */
        FitBoundsService.prototype.addToBounds = function (position) {
            /** @type {?} */
            var id = this.createIdentifier(position);
            if (this._includeInBounds$.value.has(id)) {
                return;
            }
            /** @type {?} */
            var mapBounds = this._includeInBounds$.value;
            mapBounds.set(id, position);
            this._includeInBounds$.next(mapBounds);
        };
        /**
         * @param {?} position
         * @return {?}
         */
        FitBoundsService.prototype.removeFromBounds = function (position) {
            /** @type {?} */
            var mapBounds = this._includeInBounds$.value;
            mapBounds.delete(this.createIdentifier(position));
            this._includeInBounds$.next(mapBounds);
        };
        /**
         * @param {?} position
         * @return {?}
         */
        FitBoundsService.prototype.createIdentifier = function (position) {
            return position[0] + "+" + position[1];
        };
        /**
         * @param {?} timeMs
         * @return {?}
         */
        FitBoundsService.prototype.changeFitBoundsChangeSampleTime = function (timeMs) {
            this._boundsChangeSampleTime$.next(timeMs);
        };
        /**
         * @param {?} includeInBounds
         * @return {?}
         */
        FitBoundsService.prototype.generateBounds = function (includeInBounds) {
            return this._generateBounds(includeInBounds);
        };
        /**
         * @return {?}
         */
        FitBoundsService.prototype.getBounds = function () {
            return this.bounds$;
        };
        /**
         * @private
         * @param {?} includeInBounds
         * @return {?}
         */
        FitBoundsService.prototype._generateBounds = function (includeInBounds) {
            /** @type {?} */
            var bounds = new google.maps.LatLngBounds();
            includeInBounds.forEach(( /**
             * @param {?} b
             * @return {?}
             */function (b) { return bounds.extend(new google.maps.LatLng(b[0], b[1])); }));
            return bounds;
        };
        return FitBoundsService;
    }());
    FitBoundsService.decorators = [
        { type: core.Injectable }
    ];
    /** @nocollapse */
    FitBoundsService.ctorParameters = function () { return [
        { type: MapsAPILoader }
    ]; };
    if (false) {
        /**
         * @type {?}
         * @protected
         */
        FitBoundsService.prototype.bounds$;
        /**
         * @type {?}
         * @protected
         */
        FitBoundsService.prototype._boundsChangeSampleTime$;
        /**
         * @type {?}
         * @protected
         */
        FitBoundsService.prototype._includeInBounds$;
        /** @type {?} */
        FitBoundsService.prototype._fitBoundsDetails$;
        /**
         * @type {?}
         * @protected
         */
        FitBoundsService.prototype.loader;
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/services/map.service.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var MapService = /** @class */ (function () {
        /**
         * @param {?} _loader
         * @param {?} _zone
         */
        function MapService(_loader, _zone) {
            this._loader = _loader;
            this._zone = _zone;
            this.load$ = new rxjs.BehaviorSubject(null);
        }
        Object.defineProperty(MapService.prototype, "container", {
            /**
             * @return {?}
             */
            get: function () {
                return this._container;
            },
            enumerable: false,
            configurable: true
        });
        /**
         * @return {?}
         */
        MapService.prototype.getMap = function () {
            return this._map;
        };
        /**
         * @param {?} htmlElement
         * @param {?} opts
         * @return {?}
         */
        MapService.prototype.createMap = function (htmlElement, opts) {
            var _this = this;
            return new rxjs.Observable(( /**
             * @param {?} observer
             * @return {?}
             */function (observer) {
                _this._loader.load().pipe(operators.take(1)).subscribe(( /**
                 * @return {?}
                 */function () {
                    _this._map = _this._zone.runOutsideAngular(( /**
                     * @return {?}
                     */function () { return new google.maps.Map(htmlElement, opts); }));
                    _this._container = htmlElement;
                    observer.next();
                }));
            }));
        };
        /**
         * @param {?} bounds
         * @return {?}
         */
        MapService.prototype.fitBounds = function (bounds) {
            this._map.fitBounds(bounds);
        };
        /**
         * @return {?}
         */
        MapService.prototype.destroy = function () {
            google.maps.event.clearInstanceListeners(this._map);
        };
        /**
         * @return {?}
         */
        MapService.prototype.getMinZoom = function () {
            return this._map.get('minZoom');
        };
        /**
         * @return {?}
         */
        MapService.prototype.getMaxZoom = function () {
            return this._map.get('maxZoom');
        };
        /**
         * @param {?} zoom
         * @return {?}
         */
        MapService.prototype.setMinZoom = function (zoom) {
            this._map.setOptions({ minZoom: zoom });
        };
        /**
         * @param {?} zoom
         * @return {?}
         */
        MapService.prototype.setMaxZoom = function (zoom) {
            this._map.setOptions({ maxZoom: zoom });
        };
        /**
         * @return {?}
         */
        MapService.prototype.setZoomIn = function () {
            this._map.setZoom(this._map.getZoom() + 1);
        };
        /**
         * @return {?}
         */
        MapService.prototype.setZoomOut = function () {
            this._map.setZoom(this._map.getZoom() - 1);
        };
        return MapService;
    }());
    MapService.decorators = [
        { type: core.Injectable }
    ];
    /** @nocollapse */
    MapService.ctorParameters = function () { return [
        { type: MapsAPILoader },
        { type: core.NgZone }
    ]; };
    if (false) {
        /** @type {?} */
        MapService.prototype.load$;
        /**
         * @type {?}
         * @private
         */
        MapService.prototype._map;
        /**
         * @type {?}
         * @private
         */
        MapService.prototype._container;
        /**
         * @type {?}
         * @private
         */
        MapService.prototype._loader;
        /**
         * @type {?}
         * @private
         */
        MapService.prototype._zone;
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/services/event.service.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var EventService = /** @class */ (function () {
        /**
         * @param {?} _zone
         */
        function EventService(_zone) {
            this._zone = _zone;
            this._pending = [];
        }
        /**
         * @template T
         * @param {?} name
         * @return {?}
         */
        EventService.prototype.getEventListener = function (name) {
            var _this = this;
            /** @type {?} */
            var observable$ = new rxjs.Observable(( /**
             * @param {?} observer
             * @return {?}
             */function (observer) {
                if (!_this._target) {
                    _this._pending.push({ observable: observable$, observer: observer });
                    return null;
                }
                _this._target.addListener(name, ( /**
                 * @param {?} event
                 * @return {?}
                 */function (event) {
                    _this._zone.run(( /**
                     * @return {?}
                     */function () { return observer.next(event); }));
                }));
            }));
            return observable$;
        };
        /**
         * @param {?} target
         * @return {?}
         */
        EventService.prototype.setTarget = function (target) {
            if (target === this._target) {
                return;
            }
            if (this._target) {
                this._pending = [];
            }
            this._target = target;
            this._pending.forEach(( /**
             * @param {?} subscriber
             * @return {?}
             */function (subscriber) { return subscriber.observable.subscribe(subscriber.observer); }));
            this._pending = [];
        };
        /**
         * @return {?}
         */
        EventService.prototype.destroy = function () {
            this._pending = [];
            this._target = null;
        };
        return EventService;
    }());
    EventService.decorators = [
        { type: core.Injectable }
    ];
    /** @nocollapse */
    EventService.ctorParameters = function () { return [
        { type: core.NgZone }
    ]; };
    if (false) {
        /**
         * @type {?}
         * @private
         */
        EventService.prototype._pending;
        /**
         * @type {?}
         * @private
         */
        EventService.prototype._target;
        /**
         * @type {?}
         * @private
         */
        EventService.prototype._zone;
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/constanst/map-providers.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var PROVIDERS = [
        MapService,
        EventService,
        FitBoundsService,
    ];

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/components/map/map.component.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var MapComponent = /** @class */ (function () {
        /**
         * @param {?} platformId
         * @param {?} _element
         * @param {?} mapService
         * @param {?} _eventService
         * @param {?} _fitBoundsService
         */
        function MapComponent(platformId, _element, mapService, _eventService, _fitBoundsService) {
            this._element = _element;
            this.mapService = mapService;
            this._eventService = _eventService;
            this._fitBoundsService = _fitBoundsService;
            /**
             * See https://developers.google.com/maps/documentation/javascript/reference/map#Map.bounds_changed
             */
            this.boundsChanged = this._eventService.getEventListener('bounds_changed');
            /**
             * See https://developers.google.com/maps/documentation/javascript/reference/map#Map.center_changed
             */
            this.centerChanged = this._eventService.getEventListener('center_changed');
            /**
             * See https://developers.google.com/maps/documentation/javascript/reference/map#Map.click
             */
            this.mapClick = this._eventService.getEventListener('click');
            /**
             * See https://developers.google.com/maps/documentation/javascript/reference/map#Map.dblclick
             */
            this.mapDblclick = this._eventService.getEventListener('dblclick');
            /**
             * See https://developers.google.com/maps/documentation/javascript/reference/map#Map.drag
             */
            this.mapDrag = this._eventService.getEventListener('drag');
            /**
             * See https://developers.google.com/maps/documentation/javascript/reference/map#Map.drag
             */
            this.mapDragend = this._eventService.getEventListener('dragend');
            /**
                 * See https://developers.google.com/maps/documentation/javascript/reference/map#Map.drag
                 */
            /**
             * See https://developers.google.com/maps/documentation/javascript/reference/map#Map.dragstart
             */
            this.mapDragstart = this._eventService.getEventListener('dragstart');
            /**
             * See https://developers.google.com/maps/documentation/javascript/reference/map#Map.heading_changed
             */
            this.headingChanged = this._eventService.getEventListener('heading_changed');
            /**
             * See https://developers.google.com/maps/documentation/javascript/reference/map#Map.idle
             */
            this.idle = this._eventService.getEventListener('idle');
            /**
             * See https://developers.google.com/maps/documentation/javascript/reference/map#Map.maptypeid_changed
             */
            this.maptypeidChanged = this._eventService.getEventListener('maptypeid_changed');
            /**
             * See https://developers.google.com/maps/documentation/javascript/reference/map#Map.mousemove
             */
            this.mapMousemove = this._eventService.getEventListener('mousemove');
            /**
             * See https://developers.google.com/maps/documentation/javascript/reference/map#Map.mouseout
             */
            this.mapMouseout = this._eventService.getEventListener('mouseout');
            /**
             * See https://developers.google.com/maps/documentation/javascript/reference/map#Map.mouseover
             */
            this.mapMouseover = this._eventService.getEventListener('mouseover');
            /**
             * See https://developers.google.com/maps/documentation/javascript/reference/map#Map.projection_changed
             */
            this.projectionChanged = this._eventService.getEventListener('projection_changed');
            /**
             * See https://developers.google.com/maps/documentation/javascript/reference/map#Map.rightclick
             */
            this.mapRightclick = this._eventService.getEventListener('rightclick');
            /**
             * See https://developers.google.com/maps/documentation/javascript/reference/map#Map.tilesloaded
             */
            this.tilesloaded = this._eventService.getEventListener('tilesloaded');
            /**
             * See https://developers.google.com/maps/documentation/javascript/reference/map#Map.tilt_changed
             */
            this.tiltChanged = this._eventService.getEventListener('tilt_changed');
            /**
             * See https://developers.google.com/maps/documentation/javascript/reference/map#Map.zoom_changed
             */
            this.zoomChanged = this._eventService.getEventListener('zoom_changed');
            this.mapReady = new rxjs.Subject();
            this._destroy$ = new rxjs.Subject();
            this._isBrowser = common.isPlatformBrowser(platformId);
        }
        /**
         * @return {?}
         */
        MapComponent.prototype.ngAfterContentInit = function () {
            this._onInit();
        };
        /**
         * @param {?} changes
         * @return {?}
         */
        MapComponent.prototype.ngOnChanges = function (changes) {
            if (!this.map) {
                return;
            }
            changes.center
                && !changes.center.isFirstChange()
                && this.map.setCenter(this.center);
            changes.zoom
                && !changes.zoom.isFirstChange()
                && this.map.setZoom(this.zoom);
            changes.mapTypeId
                && !changes.mapTypeId.isFirstChange()
                && this.map.setOptions({ mapTypeId: this.mapTypeId });
            changes.options
                && !changes.options.isFirstChange()
                && this.map.setOptions(this._combineOptions());
        };
        /**
         * @return {?}
         */
        MapComponent.prototype.ngOnDestroy = function () {
            this._destroy$.next(true);
            this._destroy$.complete();
            this._eventService.destroy();
            this.mapService.destroy();
        };
        /**
         * @private
         * @return {?}
         */
        MapComponent.prototype._onInit = function () {
            var _this = this;
            if (!this._isBrowser) {
                return;
            }
            /** @type {?} */
            var createMap$ = this.mapService.createMap(this._getHTMLElement(), this._combineOptions());
            createMap$.subscribe(( /**
             * @return {?}
             */function () {
                _this.map = _this.mapService.getMap();
                _this._assertInitialized();
                _this._eventService.setTarget(_this.map);
                _this.mapReady.next();
                _this.mapService.load$.next(true);
            }));
        };
        /**
         * @private
         * @return {?}
         */
        MapComponent.prototype._combineOptions = function () {
            return Object.assign(Object.assign({}, this.options), { zoom: this.zoom || this.options.zoom, center: this.center || this.options.center, mapTypeId: this.mapTypeId || this.options.mapTypeId });
        };
        /**
         * @private
         * @return {?}
         */
        MapComponent.prototype._getHTMLElement = function () {
            return this._element.nativeElement.querySelector('.c-dex-map-container');
        };
        /**
         * @private
         * @return {?}
         */
        MapComponent.prototype._assertInitialized = function () {
            if (!this.map) {
                throw Error('Cannot access Google Map information before the API has been initialized. ' +
                    'Please wait for the API to load before trying to interact with it.');
            }
        };
        return MapComponent;
    }());
    MapComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'dgm-map',
                    providers: PROVIDERS,
                    template: "<div class=\"c-dex-map\">\n    <div #container class=\"c-dex-map-container\"></div>\n    <div class=\"map-content\">\n        <ng-content></ng-content>\n    </div>\n</div>",
                    encapsulation: core.ViewEncapsulation.None,
                    changeDetection: core.ChangeDetectionStrategy.OnPush,
                    styles: [".c-dex-map{background-color:#f5f5f5!important;font-family:Roboto,Helvetica Neue,sans-serif;height:100%;overflow:hidden;position:relative;width:100%}.c-dex-map .map-container-inner{height:inherit;width:inherit}.c-dex-map .map-container-inner div{background-repeat:no-repeat}.c-dex-map .map-content{display:none}.c-dex-map .c-dex-map-container{height:100%;position:relative;width:100%;z-index:1}.c-dex-map .c-h21-map-toolbar-horizontal{box-sizing:border-box;display:flex;flex-direction:row;height:72px;left:0;padding:16px;pointer-events:none;position:absolute;top:0;width:100%;z-index:3}.c-dex-map .c-h21-map-toolbar-horizontal.c-h21-map-toolbar-horizontal__bottom{bottom:0;padding:16px 72px 16px 16px;top:auto}.c-dex-map .c-h21-map-toolbar-horizontal>:not(.flex-fill){pointer-events:auto}"]
                }] }
    ];
    /** @nocollapse */
    MapComponent.ctorParameters = function () { return [
        { type: Object, decorators: [{ type: core.Inject, args: [core.PLATFORM_ID,] }] },
        { type: core.ElementRef },
        { type: MapService },
        { type: EventService },
        { type: FitBoundsService }
    ]; };
    MapComponent.propDecorators = {
        center: [{ type: core.Input }],
        mapTypeId: [{ type: core.Input }],
        zoom: [{ type: core.Input }],
        options: [{ type: core.Input }],
        boundsChanged: [{ type: core.Output }],
        centerChanged: [{ type: core.Output }],
        mapClick: [{ type: core.Output }],
        mapDblclick: [{ type: core.Output }],
        mapDrag: [{ type: core.Output }],
        mapDragend: [{ type: core.Output }],
        mapDragstart: [{ type: core.Output }],
        headingChanged: [{ type: core.Output }],
        idle: [{ type: core.Output }],
        maptypeidChanged: [{ type: core.Output }],
        mapMousemove: [{ type: core.Output }],
        mapMouseout: [{ type: core.Output }],
        mapMouseover: [{ type: core.Output }],
        projectionChanged: [{ type: core.Output }],
        mapRightclick: [{ type: core.Output }],
        tilesloaded: [{ type: core.Output }],
        tiltChanged: [{ type: core.Output }],
        zoomChanged: [{ type: core.Output }],
        mapReady: [{ type: core.Output }]
    };
    if (false) {
        /**
         * See https://developers.google.com/maps/documentation/javascript/reference/map#MapOptions.center
         * @type {?}
         */
        MapComponent.prototype.center;
        /**
         * See https://developers.google.com/maps/documentation/javascript/reference/map#MapOptions.mapTypeId
         * @type {?}
         */
        MapComponent.prototype.mapTypeId;
        /**
         * See https://developers.google.com/maps/documentation/javascript/reference/map#MapOptions.zoom
         * @type {?}
         */
        MapComponent.prototype.zoom;
        /**
         * See https://developers.google.com/maps/documentation/javascript/reference/map#MapOptions
         * @type {?}
         */
        MapComponent.prototype.options;
        /**
         * See https://developers.google.com/maps/documentation/javascript/reference/map#Map.bounds_changed
         * @type {?}
         */
        MapComponent.prototype.boundsChanged;
        /**
         * See https://developers.google.com/maps/documentation/javascript/reference/map#Map.center_changed
         * @type {?}
         */
        MapComponent.prototype.centerChanged;
        /**
         * See https://developers.google.com/maps/documentation/javascript/reference/map#Map.click
         * @type {?}
         */
        MapComponent.prototype.mapClick;
        /**
         * See https://developers.google.com/maps/documentation/javascript/reference/map#Map.dblclick
         * @type {?}
         */
        MapComponent.prototype.mapDblclick;
        /**
         * See https://developers.google.com/maps/documentation/javascript/reference/map#Map.drag
         * @type {?}
         */
        MapComponent.prototype.mapDrag;
        /**
         * See https://developers.google.com/maps/documentation/javascript/reference/map#Map.drag
         * @type {?}
         */
        MapComponent.prototype.mapDragend;
        /**
         * See https://developers.google.com/maps/documentation/javascript/reference/map#Map.dragstart
         * @type {?}
         */
        MapComponent.prototype.mapDragstart;
        /**
         * See https://developers.google.com/maps/documentation/javascript/reference/map#Map.heading_changed
         * @type {?}
         */
        MapComponent.prototype.headingChanged;
        /**
         * See https://developers.google.com/maps/documentation/javascript/reference/map#Map.idle
         * @type {?}
         */
        MapComponent.prototype.idle;
        /**
         * See https://developers.google.com/maps/documentation/javascript/reference/map#Map.maptypeid_changed
         * @type {?}
         */
        MapComponent.prototype.maptypeidChanged;
        /**
         * See https://developers.google.com/maps/documentation/javascript/reference/map#Map.mousemove
         * @type {?}
         */
        MapComponent.prototype.mapMousemove;
        /**
         * See https://developers.google.com/maps/documentation/javascript/reference/map#Map.mouseout
         * @type {?}
         */
        MapComponent.prototype.mapMouseout;
        /**
         * See https://developers.google.com/maps/documentation/javascript/reference/map#Map.mouseover
         * @type {?}
         */
        MapComponent.prototype.mapMouseover;
        /**
         * See https://developers.google.com/maps/documentation/javascript/reference/map#Map.projection_changed
         * @type {?}
         */
        MapComponent.prototype.projectionChanged;
        /**
         * See https://developers.google.com/maps/documentation/javascript/reference/map#Map.rightclick
         * @type {?}
         */
        MapComponent.prototype.mapRightclick;
        /**
         * See https://developers.google.com/maps/documentation/javascript/reference/map#Map.tilesloaded
         * @type {?}
         */
        MapComponent.prototype.tilesloaded;
        /**
         * See https://developers.google.com/maps/documentation/javascript/reference/map#Map.tilt_changed
         * @type {?}
         */
        MapComponent.prototype.tiltChanged;
        /**
         * See https://developers.google.com/maps/documentation/javascript/reference/map#Map.zoom_changed
         * @type {?}
         */
        MapComponent.prototype.zoomChanged;
        /** @type {?} */
        MapComponent.prototype.mapReady;
        /**
         * The underlying google.maps.Map object
         *
         * See https://developers.google.com/maps/documentation/javascript/reference/map#Map
         * @type {?}
         */
        MapComponent.prototype.map;
        /**
         * @type {?}
         * @private
         */
        MapComponent.prototype._isBrowser;
        /**
         * @type {?}
         * @private
         */
        MapComponent.prototype._destroy$;
        /**
         * @type {?}
         * @private
         */
        MapComponent.prototype._element;
        /** @type {?} */
        MapComponent.prototype.mapService;
        /**
         * @type {?}
         * @private
         */
        MapComponent.prototype._eventService;
        /**
         * @type {?}
         * @protected
         */
        MapComponent.prototype._fitBoundsService;
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/components/index.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/constanst/api-config.constants.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var API_CONFIG = new core.InjectionToken('dgm MAPS_API_CONFIG');

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/models/window-ref.model.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var WindowRef = /** @class */ (function () {
        function WindowRef() {
        }
        /**
         * @return {?}
         */
        WindowRef.prototype.getNativeWindow = function () {
            return window;
        };
        return WindowRef;
    }());
    WindowRef.decorators = [
        { type: core.Injectable }
    ];

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/models/document-ref.model.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var DocumentRef = /** @class */ (function () {
        function DocumentRef() {
        }
        /**
         * @return {?}
         */
        DocumentRef.prototype.getNativeDocument = function () {
            return document;
        };
        return DocumentRef;
    }());
    DocumentRef.decorators = [
        { type: core.Injectable }
    ];

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/constanst/browser-providers.constants.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var BROWSER_PROVIDERS = [WindowRef, DocumentRef];

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/constanst/index.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/directives/bicycling-layer/bicycling-layer.directive.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Angular directive that renders a Google Maps Bicycling Layer via the Google Maps JavaScript API.
     *
     * See https://developers.google.com/maps/documentation/javascript/reference/map#BicyclingLayer
     */
    var BicyclingLayerDirective = /** @class */ (function () {
        /**
         * @param {?} _mapService
         */
        function BicyclingLayerDirective(_mapService) {
            this._mapService = _mapService;
            this._destroy$ = new rxjs.Subject();
        }
        /**
         * @return {?}
         */
        BicyclingLayerDirective.prototype.ngOnInit = function () {
            var _this = this;
            this._mapService.load$
                .pipe(operators.filter(Boolean), operators.takeUntil(this._destroy$))
                .subscribe(( /**
         * @return {?}
         */function () {
                _this._onInit();
            }));
        };
        /**
         * @return {?}
         */
        BicyclingLayerDirective.prototype.ngOnDestroy = function () {
            this._destroy$.next();
            this._destroy$.complete();
            this.bicyclingLayer && this.bicyclingLayer.setMap(null);
        };
        /**
         * @private
         * @return {?}
         */
        BicyclingLayerDirective.prototype._onInit = function () {
            this.bicyclingLayer = new google.maps.BicyclingLayer();
            this._assertInitialized();
            this.bicyclingLayer.setMap(this._mapService.getMap());
        };
        /**
         * @private
         * @return {?}
         */
        BicyclingLayerDirective.prototype._assertInitialized = function () {
            if (!this._mapService.getMap()) {
                throw Error('Cannot access Google Map information before the API has been initialized. ' +
                    'Please wait for the API to load before trying to interact with it.');
            }
            if (!this.bicyclingLayer) {
                throw Error('Cannot interact with a Google Map Bicycling Layer before it has been initialized. ' +
                    'Please wait for the Bicycling Layer to load before trying to interact with it.');
            }
        };
        return BicyclingLayerDirective;
    }());
    BicyclingLayerDirective.decorators = [
        { type: core.Directive, args: [{ selector: '[dgmBicyclingLayer]' },] }
    ];
    /** @nocollapse */
    BicyclingLayerDirective.ctorParameters = function () { return [
        { type: MapService }
    ]; };
    if (false) {
        /**
         * The underlying google.maps.BicyclingLayer object
         *
         * See https://developers.google.com/maps/documentation/javascript/reference/map#BicyclingLayer
         * @type {?}
         */
        BicyclingLayerDirective.prototype.bicyclingLayer;
        /**
         * @type {?}
         * @private
         */
        BicyclingLayerDirective.prototype._destroy$;
        /**
         * @type {?}
         * @private
         */
        BicyclingLayerDirective.prototype._mapService;
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/directives/circle/circle.directive.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Angular directive that renders a Google Maps Circle via the Google Maps JavaScript API.
     *
     * See https://developers.google.com/maps/documentation/javascript/reference/polygon#Circle
     */
    var CircleDirective = /** @class */ (function () {
        /**
         * @param {?} _mapService
         * @param {?} _eventService
         * @param {?} _ngZone
         */
        function CircleDirective(_mapService, _eventService, _ngZone) {
            this._mapService = _mapService;
            this._eventService = _eventService;
            this._ngZone = _ngZone;
            /**
             * See https://developers.google.com/maps/documentation/javascript/reference/polygon#Circle.center_changed
             */
            this.centerChanged = this._eventService.getEventListener('center_changed');
            /**
             * See https://developers.google.com/maps/documentation/javascript/reference/polygon#Circle.click
             */
            this.circleClick = this._eventService.getEventListener('click');
            /**
             * See https://developers.google.com/maps/documentation/javascript/reference/polygon#Circle.dblclick
             */
            this.circleDblclick = this._eventService.getEventListener('dblclick');
            /**
             * See https://developers.google.com/maps/documentation/javascript/reference/polygon#Circle.drag
             */
            this.circleDrag = this._eventService.getEventListener('drag');
            /**
             * See https://developers.google.com/maps/documentation/javascript/reference/polygon#Circle.dragend
             */
            this.circleDragend = this._eventService.getEventListener('dragend');
            /**
             * See https://developers.google.com/maps/documentation/javascript/reference/polygon#Circle.dragstart
             */
            this.circleDragstart = this._eventService.getEventListener('dragstart');
            /**
             * See https://developers.google.com/maps/documentation/javascript/reference/polygon#Circle.mousedown
             */
            this.circleMousedown = this._eventService.getEventListener('mousedown');
            /**
             * See https://developers.google.com/maps/documentation/javascript/reference/polygon#Circle.mousemove
             */
            this.circleMousemove = this._eventService.getEventListener('mousemove');
            /**
             * See https://developers.google.com/maps/documentation/javascript/reference/polygon#Circle.mouseout
             */
            this.circleMouseout = this._eventService.getEventListener('mouseout');
            /**
             * See https://developers.google.com/maps/documentation/javascript/reference/polygon#Circle.mouseover
             */
            this.circleMouseover = this._eventService.getEventListener('mouseover');
            /**
             * See https://developers.google.com/maps/documentation/javascript/reference/polygon#Circle.mouseup
             */
            this.circleMouseup = this._eventService.getEventListener('mouseup');
            /**
             * See https://developers.google.com/maps/documentation/javascript/reference/polygon#Circle.radius_changed
             */
            this.radiusChanged = this._eventService.getEventListener('radius_changed');
            /**
             * See https://developers.google.com/maps/documentation/javascript/reference/polygon#Circle.rightclick
             */
            this.circleRightclick = this._eventService.getEventListener('rightclick');
            this._destroy$ = new rxjs.Subject();
        }
        /**
         * @return {?}
         */
        CircleDirective.prototype.ngOnInit = function () {
            var _this = this;
            this._mapService.load$
                .pipe(operators.filter(Boolean), operators.takeUntil(this._destroy$))
                .subscribe(( /**
         * @return {?}
         */function () {
                _this._onInit();
            }));
        };
        /**
         * @param {?} changes
         * @return {?}
         */
        CircleDirective.prototype.ngOnChanges = function (changes) {
            if (!this.circle) {
                return;
            }
            changes.center
                && !changes.center.isFirstChange()
                && this.circle.setCenter(this.center);
            changes.draggable
                && !changes.draggable.isFirstChange()
                && this.circle.setDraggable(this.draggable);
            changes.editable
                && !changes.editable.isFirstChange()
                && this.circle.setEditable(this.editable);
            changes.radius
                && !changes.radius.isFirstChange()
                && this.circle.setRadius(this.radius);
            changes.options
                && !changes.options.isFirstChange()
                && this.circle.setOptions(this._combineOptions());
            changes.visible
                && !changes.visible.isFirstChange()
                && this.circle.setVisible(this.visible);
        };
        /**
         * @return {?}
         */
        CircleDirective.prototype.ngOnDestroy = function () {
            this._destroy$.next();
            this._destroy$.complete();
            this.circle && this.circle.setMap(null);
        };
        /**
         * @private
         * @return {?}
         */
        CircleDirective.prototype._onInit = function () {
            var _this = this;
            this._ngZone.runOutsideAngular(( /**
             * @return {?}
             */function () {
                _this.circle = new google.maps.Circle(_this._combineOptions());
            }));
            this._assertInitialized();
            this.circle.setMap(this._mapService.getMap());
        };
        /**
         * @private
         * @return {?}
         */
        CircleDirective.prototype._combineOptions = function () {
            return Object.assign(Object.assign({}, this.options), { center: this.center || this.options.center, draggable: this.draggable || this.options.draggable || false, editable: this.editable || this.options.editable || true, radius: this.radius || this.options.radius, visible: this.visible || this.options.visible || true });
        };
        /**
         * @private
         * @return {?}
         */
        CircleDirective.prototype._assertInitialized = function () {
            if (!this._mapService.getMap()) {
                throw Error('Cannot access Google Map information before the API has been initialized. ' +
                    'Please wait for the API to load before trying to interact with it.');
            }
            if (!this.circle) {
                throw Error('Cannot interact with a Google Map Marker before it has been initialized. ' +
                    'Please wait for the Circle to load before trying to interact with it.');
            }
        };
        return CircleDirective;
    }());
    CircleDirective.decorators = [
        { type: core.Directive, args: [{ selector: '[dgmCircle]' },] }
    ];
    /** @nocollapse */
    CircleDirective.ctorParameters = function () { return [
        { type: MapService },
        { type: EventService },
        { type: core.NgZone }
    ]; };
    CircleDirective.propDecorators = {
        center: [{ type: core.Input }],
        draggable: [{ type: core.Input }],
        editable: [{ type: core.Input }],
        radius: [{ type: core.Input }],
        options: [{ type: core.Input }],
        visible: [{ type: core.Input }],
        centerChanged: [{ type: core.Output }],
        circleClick: [{ type: core.Output }],
        circleDblclick: [{ type: core.Output }],
        circleDrag: [{ type: core.Output }],
        circleDragend: [{ type: core.Output }],
        circleDragstart: [{ type: core.Output }],
        circleMousedown: [{ type: core.Output }],
        circleMousemove: [{ type: core.Output }],
        circleMouseout: [{ type: core.Output }],
        circleMouseover: [{ type: core.Output }],
        circleMouseup: [{ type: core.Output }],
        radiusChanged: [{ type: core.Output }],
        circleRightclick: [{ type: core.Output }]
    };
    if (false) {
        /**
         * See https://developers.google.com/maps/documentation/javascript/reference/polygon#CircleOptions.center
         * @type {?}
         */
        CircleDirective.prototype.center;
        /**
         * See https://developers.google.com/maps/documentation/javascript/reference/polygon#CircleOptions.draggable
         * @type {?}
         */
        CircleDirective.prototype.draggable;
        /**
         * See https://developers.google.com/maps/documentation/javascript/reference/polygon#CircleOptions.editable
         * @type {?}
         */
        CircleDirective.prototype.editable;
        /**
         * See https://developers.google.com/maps/documentation/javascript/reference/polygon#CircleOptions.radius
         * @type {?}
         */
        CircleDirective.prototype.radius;
        /**
         * See https://developers.google.com/maps/documentation/javascript/reference/polygon#CircleOptions
         * @type {?}
         */
        CircleDirective.prototype.options;
        /**
         * See https://developers.google.com/maps/documentation/javascript/reference/polygon#CircleOptions.visible
         * @type {?}
         */
        CircleDirective.prototype.visible;
        /**
         * See https://developers.google.com/maps/documentation/javascript/reference/polygon#Circle.center_changed
         * @type {?}
         */
        CircleDirective.prototype.centerChanged;
        /**
         * See https://developers.google.com/maps/documentation/javascript/reference/polygon#Circle.click
         * @type {?}
         */
        CircleDirective.prototype.circleClick;
        /**
         * See https://developers.google.com/maps/documentation/javascript/reference/polygon#Circle.dblclick
         * @type {?}
         */
        CircleDirective.prototype.circleDblclick;
        /**
         * See https://developers.google.com/maps/documentation/javascript/reference/polygon#Circle.drag
         * @type {?}
         */
        CircleDirective.prototype.circleDrag;
        /**
         * See https://developers.google.com/maps/documentation/javascript/reference/polygon#Circle.dragend
         * @type {?}
         */
        CircleDirective.prototype.circleDragend;
        /**
         * See https://developers.google.com/maps/documentation/javascript/reference/polygon#Circle.dragstart
         * @type {?}
         */
        CircleDirective.prototype.circleDragstart;
        /**
         * See https://developers.google.com/maps/documentation/javascript/reference/polygon#Circle.mousedown
         * @type {?}
         */
        CircleDirective.prototype.circleMousedown;
        /**
         * See https://developers.google.com/maps/documentation/javascript/reference/polygon#Circle.mousemove
         * @type {?}
         */
        CircleDirective.prototype.circleMousemove;
        /**
         * See https://developers.google.com/maps/documentation/javascript/reference/polygon#Circle.mouseout
         * @type {?}
         */
        CircleDirective.prototype.circleMouseout;
        /**
         * See https://developers.google.com/maps/documentation/javascript/reference/polygon#Circle.mouseover
         * @type {?}
         */
        CircleDirective.prototype.circleMouseover;
        /**
         * See https://developers.google.com/maps/documentation/javascript/reference/polygon#Circle.mouseup
         * @type {?}
         */
        CircleDirective.prototype.circleMouseup;
        /**
         * See https://developers.google.com/maps/documentation/javascript/reference/polygon#Circle.radius_changed
         * @type {?}
         */
        CircleDirective.prototype.radiusChanged;
        /**
         * See https://developers.google.com/maps/documentation/javascript/reference/polygon#Circle.rightclick
         * @type {?}
         */
        CircleDirective.prototype.circleRightclick;
        /**
         * The underlying google.maps.Circle object
         *
         * See https://developers.google.com/maps/documentation/javascript/reference/polygon#Circle
         * @type {?}
         */
        CircleDirective.prototype.circle;
        /**
         * @type {?}
         * @private
         */
        CircleDirective.prototype._destroy$;
        /**
         * @type {?}
         * @private
         */
        CircleDirective.prototype._mapService;
        /**
         * @type {?}
         * @private
         */
        CircleDirective.prototype._eventService;
        /**
         * @type {?}
         * @private
         */
        CircleDirective.prototype._ngZone;
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/services/abstract/abstract-map-fitbounds-accessor.service.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @abstract
     */
    var FitBoundsAccessor = /** @class */ (function () {
        function FitBoundsAccessor() {
        }
        return FitBoundsAccessor;
    }());
    FitBoundsAccessor.decorators = [
        { type: core.Injectable }
    ];
    if (false) {
        /**
         * @abstract
         * @return {?}
         */
        FitBoundsAccessor.prototype.getFitBounds = function () { };
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/directives/fitbounds/fitbounds.directive.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    // interfaces
    var FitBoundsDirective = /** @class */ (function () {
        /**
         * @param {?} _fitBoundsAccessor
         * @param {?} _fitBoundsService
         */
        function FitBoundsDirective(_fitBoundsAccessor, _fitBoundsService) {
            this._fitBoundsAccessor = _fitBoundsAccessor;
            this._fitBoundsService = _fitBoundsService;
            this.dexFitBounds = true;
            this._destroyed$ = new rxjs.Subject();
            this._latestFitBoundsDetails = null;
        }
        /**
         * @return {?}
         */
        FitBoundsDirective.prototype.ngOnInit = function () {
            var _this = this;
            this._fitBoundsAccessor
                .getFitBounds()
                .pipe(operators.distinctUntilChanged(( /**
         * @param {?} x
         * @param {?} y
         * @return {?}
         */function (x, y) { return x.position[0] === y.position[0] && x.position[1] === y.position[1]; })), operators.takeUntil(this._destroyed$))
                .subscribe(( /**
         * @param {?} details
         * @return {?}
         */function (details) { return _this._updateBounds(details); }));
        };
        /**
         * @return {?}
         */
        FitBoundsDirective.prototype.ngOnChanges = function () {
            this._updateBounds();
        };
        /**
         * @return {?}
         */
        FitBoundsDirective.prototype.ngOnDestroy = function () {
            this._destroyed$.next();
            this._destroyed$.complete();
            this._latestFitBoundsDetails && this._fitBoundsService.removeFromBounds(this._latestFitBoundsDetails.position);
        };
        /**
         * @private
         * @param {?=} newFitBoundsDetails
         * @return {?}
         */
        FitBoundsDirective.prototype._updateBounds = function (newFitBoundsDetails) {
            this._latestFitBoundsDetails && this._fitBoundsService.removeFromBounds(this._latestFitBoundsDetails.position);
            if (newFitBoundsDetails) {
                this._latestFitBoundsDetails = newFitBoundsDetails;
            }
            if (!this._latestFitBoundsDetails) {
                return;
            }
            this.dexFitBounds && this._fitBoundsService.addToBounds(this._latestFitBoundsDetails.position);
        };
        return FitBoundsDirective;
    }());
    FitBoundsDirective.decorators = [
        { type: core.Directive, args: [{ selector: '[dgmFitBounds]' },] }
    ];
    /** @nocollapse */
    FitBoundsDirective.ctorParameters = function () { return [
        { type: FitBoundsAccessor, decorators: [{ type: core.Self }] },
        { type: FitBoundsService }
    ]; };
    FitBoundsDirective.propDecorators = {
        dexFitBounds: [{ type: core.Input }]
    };
    if (false) {
        /** @type {?} */
        FitBoundsDirective.prototype.dexFitBounds;
        /**
         * @type {?}
         * @private
         */
        FitBoundsDirective.prototype._destroyed$;
        /**
         * @type {?}
         * @private
         */
        FitBoundsDirective.prototype._latestFitBoundsDetails;
        /**
         * @type {?}
         * @private
         */
        FitBoundsDirective.prototype._fitBoundsAccessor;
        /**
         * @type {?}
         * @private
         */
        FitBoundsDirective.prototype._fitBoundsService;
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/directives/ground-overlay/ground-overlay.directive.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Angular directive that renders a Google Maps Ground Overlay via the Google Maps JavaScript API.
     *
     * See https://developers.google.com/maps/documentation/javascript/reference/image-overlay#GroundOverlay
     */
    var GroundOverlayDirective = /** @class */ (function () {
        /**
         * @param {?} _mapService
         * @param {?} _eventService
         * @param {?} _ngZone
         */
        function GroundOverlayDirective(_mapService, _eventService, _ngZone) {
            this._mapService = _mapService;
            this._eventService = _eventService;
            this._ngZone = _ngZone;
            /**
             * See https://developers.google.com/maps/documentation/javascript/reference/image-overlay#GroundOverlay.click
             */
            this.groundOverlayClick = this._eventService.getEventListener('click');
            /**
             * See https://developers.google.com/maps/documentation/javascript/reference/image-overlay
             * #GroundOverlay.dblclick
             */
            this.groundOverlayDblclick = this._eventService.getEventListener('dblclick');
            this._destroy$ = new rxjs.Subject();
        }
        /**
         * @return {?}
         */
        GroundOverlayDirective.prototype.ngOnInit = function () {
            var _this = this;
            this._mapService.load$
                .pipe(operators.filter(Boolean), operators.takeUntil(this._destroy$))
                .subscribe(( /**
         * @return {?}
         */function () {
                _this._onInit();
            }));
        };
        /**
         * @param {?} changes
         * @return {?}
         */
        GroundOverlayDirective.prototype.ngOnChanges = function (changes) {
            changes.opacity
                && !changes.opacity.isFirstChange()
                && this.groundOverlay.setOpacity(this.opacity);
            changes.url
                && !changes.url.isFirstChange()
                && this._urlChanges();
        };
        /**
         * @return {?}
         */
        GroundOverlayDirective.prototype.ngOnDestroy = function () {
            this._destroy$.next();
            this._destroy$.complete();
            this.groundOverlay && this.groundOverlay.setMap(null);
        };
        /**
         * @private
         * @return {?}
         */
        GroundOverlayDirective.prototype._onInit = function () {
            var _this = this;
            if (!this.bounds) {
                return;
            }
            this._ngZone.runOutsideAngular(( /**
             * @return {?}
             */function () {
                _this.groundOverlay = new google.maps.GroundOverlay(_this.url, _this.bounds, _this._combineOptions());
            }));
            this._assertInitialized();
            this.groundOverlay.setMap(this._mapService.getMap());
            this._eventService.setTarget(this.groundOverlay);
        };
        /**
         * @private
         * @return {?}
         */
        GroundOverlayDirective.prototype._combineOptions = function () {
            return {
                clickable: this.clickable || true,
                opacity: this.opacity || null,
            };
        };
        /**
         * @private
         * @return {?}
         */
        GroundOverlayDirective.prototype._urlChanges = function () {
            this.groundOverlay.set('url', this.url);
            this.groundOverlay.setMap(null);
            this.groundOverlay.setMap(this._mapService.getMap());
        };
        /**
         * @private
         * @return {?}
         */
        GroundOverlayDirective.prototype._assertInitialized = function () {
            if (!this._mapService.getMap()) {
                throw Error('Cannot access Google Map information before the API has been initialized. ' +
                    'Please wait for the API to load before trying to interact with it.');
            }
            if (!this.groundOverlay) {
                throw Error('Cannot interact with a Google Map Ground Overlay before it has been initialized. ' +
                    'Please wait for the Ground Overlay to load before trying to interact with it.');
            }
        };
        return GroundOverlayDirective;
    }());
    GroundOverlayDirective.decorators = [
        { type: core.Directive, args: [{ selector: '[dgmGroundOverlay]' },] }
    ];
    /** @nocollapse */
    GroundOverlayDirective.ctorParameters = function () { return [
        { type: MapService },
        { type: EventService },
        { type: core.NgZone }
    ]; };
    GroundOverlayDirective.propDecorators = {
        bounds: [{ type: core.Input }],
        url: [{ type: core.Input }],
        clickable: [{ type: core.Input }],
        opacity: [{ type: core.Input }],
        groundOverlayClick: [{ type: core.Output }],
        groundOverlayDblclick: [{ type: core.Output }]
    };
    if (false) {
        /**
         * See https://developers.google.com/maps/documentation/javascript/reference/image-overlay#GroundOverlay
         * @type {?}
         */
        GroundOverlayDirective.prototype.bounds;
        /**
         * See https://developers.google.com/maps/documentation/javascript/reference/image-overlay#GroundOverlay
         * @type {?}
         */
        GroundOverlayDirective.prototype.url;
        /**
         * See https://developers.google.com/maps/documentation/javascript/reference/image-overlay#GroundOverlayOptions.clickable
         * @type {?}
         */
        GroundOverlayDirective.prototype.clickable;
        /**
         * See https://developers.google.com/maps/documentation/javascript/reference/image-overlay#GroundOverlayOptions.opacity
         * @type {?}
         */
        GroundOverlayDirective.prototype.opacity;
        /**
         * See https://developers.google.com/maps/documentation/javascript/reference/image-overlay#GroundOverlay.click
         * @type {?}
         */
        GroundOverlayDirective.prototype.groundOverlayClick;
        /**
         * See https://developers.google.com/maps/documentation/javascript/reference/image-overlay
         * #GroundOverlay.dblclick
         * @type {?}
         */
        GroundOverlayDirective.prototype.groundOverlayDblclick;
        /**
         * The underlying google.maps.GroundOverlay object
         *
         * See https://developers.google.com/maps/documentation/javascript/reference/image-overlay#GroundOverlay
         * @type {?}
         */
        GroundOverlayDirective.prototype.groundOverlay;
        /**
         * @type {?}
         * @private
         */
        GroundOverlayDirective.prototype._destroy$;
        /**
         * @type {?}
         * @private
         */
        GroundOverlayDirective.prototype._mapService;
        /**
         * @type {?}
         * @private
         */
        GroundOverlayDirective.prototype._eventService;
        /**
         * @type {?}
         * @private
         */
        GroundOverlayDirective.prototype._ngZone;
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/directives/kml-layer/kml-layer.directive.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Angular directive that renders a Google Maps Kml Layer via the Google Maps JavaScript API.
     *
     * See https://developers.google.com/maps/documentation/javascript/reference/kml#KmlLayer
     */
    var KmlLayerDirective = /** @class */ (function () {
        /**
         * @param {?} _mapService
         * @param {?} _eventService
         * @param {?} _ngZone
         */
        function KmlLayerDirective(_mapService, _eventService, _ngZone) {
            this._mapService = _mapService;
            this._eventService = _eventService;
            this._ngZone = _ngZone;
            /**
             * See https://developers.google.com/maps/documentation/javascript/reference/kml
             * #KmlLayer.defaultviewport_changed
             */
            this.defaultviewportChanged = this._eventService.getEventListener('defaultviewport_changed');
            /**
             * See https://developers.google.com/maps/documentation/javascript/reference/kml#KmlLayer.status_changed
             */
            this.statusChanged = this._eventService.getEventListener('status_changed');
            this._destroy$ = new rxjs.Subject();
        }
        /**
         * @return {?}
         */
        KmlLayerDirective.prototype.ngOnInit = function () {
            var _this = this;
            this._mapService.load$
                .pipe(operators.filter(Boolean), operators.takeUntil(this._destroy$))
                .subscribe(( /**
         * @return {?}
         */function () {
                _this._onInit();
            }));
        };
        /**
         * @param {?} changes
         * @return {?}
         */
        KmlLayerDirective.prototype.ngOnChanges = function (changes) {
            if (!this.kmlLayer) {
                return;
            }
            changes.options
                && !changes.options.isFirstChange()
                && this.kmlLayer.setOptions(this._combineOptions());
            changes.url
                && !changes.url.isFirstChange()
                && this.kmlLayer.setUrl(this.url);
        };
        /**
         * @return {?}
         */
        KmlLayerDirective.prototype.ngOnDestroy = function () {
            this._destroy$.next();
            this._destroy$.complete();
            this.kmlLayer && this.kmlLayer.setMap(null);
        };
        /**
         * @private
         * @return {?}
         */
        KmlLayerDirective.prototype._onInit = function () {
            var _this = this;
            this._ngZone.runOutsideAngular(( /**
             * @return {?}
             */function () {
                _this.kmlLayer = new google.maps.KmlLayer(_this._combineOptions());
            }));
            this._assertInitialized();
            this.kmlLayer.setMap(this._mapService.getMap());
        };
        /**
         * @private
         * @return {?}
         */
        KmlLayerDirective.prototype._combineOptions = function () {
            return Object.assign(Object.assign({}, this.options), { url: this.url || this.options.url });
        };
        /**
         * @private
         * @return {?}
         */
        KmlLayerDirective.prototype._assertInitialized = function () {
            if (!this._mapService.getMap()) {
                throw Error('Cannot access Google Map information before the API has been initialized. ' +
                    'Please wait for the API to load before trying to interact with it.');
            }
            if (!this.kmlLayer) {
                throw Error('Cannot interact with a Google Map Kml Layer before it has been initialized. ' +
                    'Please wait for the Kml Layer to load before trying to interact with it.');
            }
        };
        return KmlLayerDirective;
    }());
    KmlLayerDirective.decorators = [
        { type: core.Directive, args: [{ selector: '[dgmKmlLayer]' },] }
    ];
    /** @nocollapse */
    KmlLayerDirective.ctorParameters = function () { return [
        { type: MapService },
        { type: EventService },
        { type: core.NgZone }
    ]; };
    KmlLayerDirective.propDecorators = {
        options: [{ type: core.Input }],
        url: [{ type: core.Input }],
        defaultviewportChanged: [{ type: core.Output }],
        statusChanged: [{ type: core.Output }]
    };
    if (false) {
        /**
         * See https://developers.google.com/maps/documentation/javascript/reference/kml#KmlLayerOptions
         * @type {?}
         */
        KmlLayerDirective.prototype.options;
        /**
         * See https://developers.google.com/maps/documentation/javascript/reference/kml#KmlLayerOptions.url
         * @type {?}
         */
        KmlLayerDirective.prototype.url;
        /**
         * See https://developers.google.com/maps/documentation/javascript/reference/kml
         * #KmlLayer.defaultviewport_changed
         * @type {?}
         */
        KmlLayerDirective.prototype.defaultviewportChanged;
        /**
         * See https://developers.google.com/maps/documentation/javascript/reference/kml#KmlLayer.status_changed
         * @type {?}
         */
        KmlLayerDirective.prototype.statusChanged;
        /**
         * The underlying google.maps.KmlLayer object
         *
         * See https://developers.google.com/maps/documentation/javascript/reference/kml#KmlLayer
         * @type {?}
         */
        KmlLayerDirective.prototype.kmlLayer;
        /**
         * @type {?}
         * @private
         */
        KmlLayerDirective.prototype._destroy$;
        /**
         * @type {?}
         * @private
         */
        KmlLayerDirective.prototype._mapService;
        /**
         * @type {?}
         * @private
         */
        KmlLayerDirective.prototype._eventService;
        /**
         * @type {?}
         * @private
         */
        KmlLayerDirective.prototype._ngZone;
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/directives/marker/marker.directive.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Angular directive that renders a Google Maps Marker via the Google Maps JavaScript API.
     *
     * See https://developers.google.com/maps/documentation/javascript/reference/map#Marker
     */
    var MarkerDirective = /** @class */ (function () {
        /**
         * @param {?} _mapService
         * @param {?} _eventService
         * @param {?} _ngZone
         */
        function MarkerDirective(_mapService, _eventService, _ngZone) {
            this._mapService = _mapService;
            this._eventService = _eventService;
            this._ngZone = _ngZone;
            /**
             * See https://developers.google.com/maps/documentation/javascript/reference/marker#Marker.dblclick
             */
            this.markerDblclick = this._eventService.getEventListener('dblclick');
            /**
             * See https://developers.google.com/maps/documentation/javascript/reference/marker#Marker.drag
             */
            this.markerDrag = this._eventService.getEventListener('drag');
            /**
             * See https://developers.google.com/maps/documentation/javascript/reference/marker#Marker.dragend
             */
            this.markerDragend = this._eventService.getEventListener('dragend');
            /**
             * See https://developers.google.com/maps/documentation/javascript/reference/marker#Marker.draggable_changed
             */
            this.draggableChanged = this._eventService.getEventListener('draggable_changed');
            /**
             * See https://developers.google.com/maps/documentation/javascript/reference/marker#Marker.dragstart
             */
            this.markerDragstart = this._eventService.getEventListener('dragstart');
            /**
             * See https://developers.google.com/maps/documentation/javascript/reference/marker#Marker.flat_changed
             */
            this.flatChanged = this._eventService.getEventListener('flat_changed');
            /**
             * See https://developers.google.com/maps/documentation/javascript/reference/marker#Marker.icon_changed
             */
            this.iconChanged = this._eventService.getEventListener('icon_changed');
            /**
             * See https://developers.google.com/maps/documentation/javascript/reference/marker#Marker.mousedown
             */
            this.markerMousedown = this._eventService.getEventListener('mousedown');
            /**
             * See https://developers.google.com/maps/documentation/javascript/reference/marker#Marker.mouseout
             */
            this.markerMouseout = this._eventService.getEventListener('mouseout');
            /**
             * See https://developers.google.com/maps/documentation/javascript/reference/marker#Marker.mouseover
             */
            this.markerMouseover = this._eventService.getEventListener('mouseover');
            /**
             * See https://developers.google.com/maps/documentation/javascript/reference/marker#Marker.mouseup
             */
            this.markerMouseup = this._eventService.getEventListener('mouseup');
            /**
             * See developers.google.com/maps/documentation/javascript/reference/marker#Marker.position_changed
             */
            this.positionChanged = this._eventService.getEventListener('position_changed');
            /**
             * See https://developers.google.com/maps/documentation/javascript/reference/marker#Marker.rightclick
             */
            this.markerRightclick = this._eventService.getEventListener('rightclick');
            /**
             * See https://developers.google.com/maps/documentation/javascript/reference/marker#Marker.shape_changed
             */
            this.shapeChanged = this._eventService.getEventListener('shape_changed');
            /**
             * See https://developers.google.com/maps/documentation/javascript/reference/marker#Marker.title_changed
             */
            this.titleChanged = this._eventService.getEventListener('title_changed');
            /**
             * See https://developers.google.com/maps/documentation/javascript/reference/marker#Marker.visible_changed
             */
            this.visibleChanged = this._eventService.getEventListener('visible_changed');
            /**
             * See https://developers.google.com/maps/documentation/javascript/reference/marker#Marker.zindex_changed
             */
            this.zindexChanged = this._eventService.getEventListener('zindex_changed');
            this._destroy$ = new rxjs.Subject();
        }
        /**
         * @return {?}
         */
        MarkerDirective.prototype.ngOnInit = function () {
            var _this = this;
            this._mapService.load$
                .pipe(operators.filter(Boolean), operators.takeUntil(this._destroy$))
                .subscribe(( /**
         * @return {?}
         */function () {
                _this._onInit();
            }));
        };
        /**
         * @param {?} changes
         * @return {?}
         */
        MarkerDirective.prototype.ngOnChanges = function (changes) {
            if (!this.marker) {
                return;
            }
            changes.clickable
                && !changes.clickable.isFirstChange()
                && this.marker.setClickable(this.clickable);
            changes.draggable
                && !changes.draggable.isFirstChange()
                && this.marker.setDraggable(this.draggable);
            changes.label
                && !changes.label.isFirstChange()
                && this.marker.setLabel(this.label);
            changes.position
                && !changes.position.isFirstChange()
                && this.marker.setPosition(this.position);
            changes.options
                && !changes.options.isFirstChange()
                && this.marker.setOptions(this._combineOptions());
            changes.title
                && !changes.title.isFirstChange()
                && this.marker.setTitle(this.title);
            changes.visible
                && !changes.visible.isFirstChange()
                && this.marker.setVisible(this.visible);
        };
        /**
         * @return {?}
         */
        MarkerDirective.prototype.ngOnDestroy = function () {
            this._destroy$.next();
            this._destroy$.complete();
            this.marker && this.marker.setMap(null);
        };
        /**
         * @private
         * @return {?}
         */
        MarkerDirective.prototype._onInit = function () {
            var _this = this;
            this._ngZone.runOutsideAngular(( /**
             * @return {?}
             */function () {
                _this.marker = new google.maps.Marker(_this._combineOptions());
            }));
            this._assertInitialized();
            this.marker.setMap(this._mapService.getMap());
        };
        /**
         * @private
         * @return {?}
         */
        MarkerDirective.prototype._combineOptions = function () {
            return Object.assign(Object.assign({}, this.options), { clickable: this.clickable || this.options.clickable || true, draggable: this.draggable || this.options.draggable || false, label: this.label || this.options.label || null, position: this.position || this.options.position, title: this.title || this.options.title || null, visible: this.visible || this.options.visible || true });
        };
        /**
         * @private
         * @return {?}
         */
        MarkerDirective.prototype._assertInitialized = function () {
            if (!this._mapService.getMap()) {
                throw Error('Cannot access Google Map information before the API has been initialized. ' +
                    'Please wait for the API to load before trying to interact with it.');
            }
            if (!this.marker) {
                throw Error('Cannot interact with a Google Map Marker before it has been initialized. ' +
                    'Please wait for the Marker to load before trying to interact with it.');
            }
        };
        return MarkerDirective;
    }());
    MarkerDirective.decorators = [
        { type: core.Directive, args: [{ selector: '[dgmMarker]' },] }
    ];
    /** @nocollapse */
    MarkerDirective.ctorParameters = function () { return [
        { type: MapService },
        { type: EventService },
        { type: core.NgZone }
    ]; };
    MarkerDirective.propDecorators = {
        clickable: [{ type: core.Input }],
        draggable: [{ type: core.Input }],
        label: [{ type: core.Input }],
        position: [{ type: core.Input }],
        options: [{ type: core.Input }],
        title: [{ type: core.Input }],
        visible: [{ type: core.Input }],
        markerDblclick: [{ type: core.Output }],
        markerDrag: [{ type: core.Output }],
        markerDragend: [{ type: core.Output }],
        draggableChanged: [{ type: core.Output }],
        markerDragstart: [{ type: core.Output }],
        flatChanged: [{ type: core.Output }],
        iconChanged: [{ type: core.Output }],
        markerMousedown: [{ type: core.Output }],
        markerMouseout: [{ type: core.Output }],
        markerMouseover: [{ type: core.Output }],
        markerMouseup: [{ type: core.Output }],
        positionChanged: [{ type: core.Output }],
        markerRightclick: [{ type: core.Output }],
        shapeChanged: [{ type: core.Output }],
        titleChanged: [{ type: core.Output }],
        visibleChanged: [{ type: core.Output }],
        zindexChanged: [{ type: core.Output }]
    };
    if (false) {
        /**
         * See https://developers.google.com/maps/documentation/javascript/reference/marker#MarkerOptions.clickable
         * @type {?}
         */
        MarkerDirective.prototype.clickable;
        /**
         * See https://developers.google.com/maps/documentation/javascript/reference/marker#MarkerOptions.draggable
         * @type {?}
         */
        MarkerDirective.prototype.draggable;
        /**
         * See https://developers.google.com/maps/documentation/javascript/reference/marker#MarkerOptions.label
         * @type {?}
         */
        MarkerDirective.prototype.label;
        /**
         * See https://developers.google.com/maps/documentation/javascript/reference/marker#MarkerOptions.position
         * @type {?}
         */
        MarkerDirective.prototype.position;
        /**
         * See https://developers.google.com/maps/documentation/javascript/reference/marker#MarkerOptions
         * @type {?}
         */
        MarkerDirective.prototype.options;
        /**
         * See developers.google.com/maps/documentation/javascript/reference/marker#MarkerOptions.title
         * @type {?}
         */
        MarkerDirective.prototype.title;
        /**
         * See https://developers.google.com/maps/documentation/javascript/reference/marker#MarkerOptions.visible
         * @type {?}
         */
        MarkerDirective.prototype.visible;
        /**
         * See https://developers.google.com/maps/documentation/javascript/reference/marker#Marker.dblclick
         * @type {?}
         */
        MarkerDirective.prototype.markerDblclick;
        /**
         * See https://developers.google.com/maps/documentation/javascript/reference/marker#Marker.drag
         * @type {?}
         */
        MarkerDirective.prototype.markerDrag;
        /**
         * See https://developers.google.com/maps/documentation/javascript/reference/marker#Marker.dragend
         * @type {?}
         */
        MarkerDirective.prototype.markerDragend;
        /**
         * See https://developers.google.com/maps/documentation/javascript/reference/marker#Marker.draggable_changed
         * @type {?}
         */
        MarkerDirective.prototype.draggableChanged;
        /**
         * See https://developers.google.com/maps/documentation/javascript/reference/marker#Marker.dragstart
         * @type {?}
         */
        MarkerDirective.prototype.markerDragstart;
        /**
         * See https://developers.google.com/maps/documentation/javascript/reference/marker#Marker.flat_changed
         * @type {?}
         */
        MarkerDirective.prototype.flatChanged;
        /**
         * See https://developers.google.com/maps/documentation/javascript/reference/marker#Marker.icon_changed
         * @type {?}
         */
        MarkerDirective.prototype.iconChanged;
        /**
         * See https://developers.google.com/maps/documentation/javascript/reference/marker#Marker.mousedown
         * @type {?}
         */
        MarkerDirective.prototype.markerMousedown;
        /**
         * See https://developers.google.com/maps/documentation/javascript/reference/marker#Marker.mouseout
         * @type {?}
         */
        MarkerDirective.prototype.markerMouseout;
        /**
         * See https://developers.google.com/maps/documentation/javascript/reference/marker#Marker.mouseover
         * @type {?}
         */
        MarkerDirective.prototype.markerMouseover;
        /**
         * See https://developers.google.com/maps/documentation/javascript/reference/marker#Marker.mouseup
         * @type {?}
         */
        MarkerDirective.prototype.markerMouseup;
        /**
         * See developers.google.com/maps/documentation/javascript/reference/marker#Marker.position_changed
         * @type {?}
         */
        MarkerDirective.prototype.positionChanged;
        /**
         * See https://developers.google.com/maps/documentation/javascript/reference/marker#Marker.rightclick
         * @type {?}
         */
        MarkerDirective.prototype.markerRightclick;
        /**
         * See https://developers.google.com/maps/documentation/javascript/reference/marker#Marker.shape_changed
         * @type {?}
         */
        MarkerDirective.prototype.shapeChanged;
        /**
         * See https://developers.google.com/maps/documentation/javascript/reference/marker#Marker.title_changed
         * @type {?}
         */
        MarkerDirective.prototype.titleChanged;
        /**
         * See https://developers.google.com/maps/documentation/javascript/reference/marker#Marker.visible_changed
         * @type {?}
         */
        MarkerDirective.prototype.visibleChanged;
        /**
         * See https://developers.google.com/maps/documentation/javascript/reference/marker#Marker.zindex_changed
         * @type {?}
         */
        MarkerDirective.prototype.zindexChanged;
        /**
         * The underlying google.maps.Marker object
         *
         * See https://developers.google.com/maps/documentation/javascript/reference/map#Marker
         * @type {?}
         */
        MarkerDirective.prototype.marker;
        /**
         * @type {?}
         * @private
         */
        MarkerDirective.prototype._destroy$;
        /**
         * @type {?}
         * @private
         */
        MarkerDirective.prototype._mapService;
        /**
         * @type {?}
         * @private
         */
        MarkerDirective.prototype._eventService;
        /**
         * @type {?}
         * @private
         */
        MarkerDirective.prototype._ngZone;
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/directives/polygon/polygon.directive.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Angular directive that renders a Google Maps Polygon via the Google Maps JavaScript API.
     *
     * See https://developers.google.com/maps/documentation/javascript/reference/polygon#Polygon
     */
    var PolygonDirective = /** @class */ (function () {
        /**
         * @param {?} _mapService
         * @param {?} _eventService
         * @param {?} _ngZone
         */
        function PolygonDirective(_mapService, _eventService, _ngZone) {
            this._mapService = _mapService;
            this._eventService = _eventService;
            this._ngZone = _ngZone;
            /**
             * See https://developers.google.com/maps/documentation/javascript/reference/polygon#Polygon.click
             */
            this.polygonClick = this._eventService.getEventListener('click');
            /**
             * See https://developers.google.com/maps/documentation/javascript/reference/polygon#Polygon.dblclick
             */
            this.polygonDblclick = this._eventService.getEventListener('dblclick');
            /**
             * See https://developers.google.com/maps/documentation/javascript/reference/polygon#Polygon.drag
             */
            this.polygonDrag = this._eventService.getEventListener('drag');
            /**
             * See https://developers.google.com/maps/documentation/javascript/reference/polygon#Polygon.dragend
             */
            this.polygonDragend = this._eventService.getEventListener('dragend');
            /**
             * See https://developers.google.com/maps/documentation/javascript/reference/polygon#Polygon.dragstart
             */
            this.polygonDragstart = this._eventService.getEventListener('dragstart');
            /**
             * See https://developers.google.com/maps/documentation/javascript/reference/polygon#Polygon.mousedown
             */
            this.polygonMousedown = this._eventService.getEventListener('mousedown');
            /**
             * See https://developers.google.com/maps/documentation/javascript/reference/polygon#Polygon.mousemove
             */
            this.polygonMousemove = this._eventService.getEventListener('mousemove');
            /**
             * See https://developers.google.com/maps/documentation/javascript/reference/polygon#Polygon.mouseout
             */
            this.polygonMouseout = this._eventService.getEventListener('mouseout');
            /**
             * See https://developers.google.com/maps/documentation/javascript/reference/polygon#Polygon.mouseover
             */
            this.polygonMouseover = this._eventService.getEventListener('mouseover');
            /**
             * See https://developers.google.com/maps/documentation/javascript/reference/polygon#Polygon.mouseup
             */
            this.polygonMouseup = this._eventService.getEventListener('mouseup');
            /**
             * See https://developers.google.com/maps/documentation/javascript/reference/polygon#Polygon.rightclick
             */
            this.polygonRightclick = this._eventService.getEventListener('rightclick');
            this._destroy$ = new rxjs.Subject();
        }
        /**
         * @return {?}
         */
        PolygonDirective.prototype.ngOnInit = function () {
            var _this = this;
            this._mapService.load$
                .pipe(operators.filter(Boolean), operators.takeUntil(this._destroy$))
                .subscribe(( /**
         * @return {?}
         */function () {
                _this._onInit();
            }));
        };
        /**
         * @param {?} changes
         * @return {?}
         */
        PolygonDirective.prototype.ngOnChanges = function (changes) {
            if (!this.polygon) {
                return;
            }
            changes.draggable
                && !changes.draggable.isFirstChange()
                && this.polygon.setDraggable(this.draggable);
            changes.editable
                && !changes.editable.isFirstChange()
                && this.polygon.setEditable(this.editable);
            changes.options
                && !changes.options.isFirstChange()
                && this.polygon.setOptions(this._combineOptions());
            changes.paths
                && !changes.paths.isFirstChange()
                && this.polygon.setPaths(this.paths);
            changes.visible
                && !changes.visible.isFirstChange()
                && this.polygon.setVisible(this.visible);
        };
        /**
         * @return {?}
         */
        PolygonDirective.prototype.ngOnDestroy = function () {
            this._destroy$.next();
            this._destroy$.complete();
            this.polygon && this.polygon.setMap(null);
        };
        /**
         * @private
         * @return {?}
         */
        PolygonDirective.prototype._onInit = function () {
            var _this = this;
            this._ngZone.runOutsideAngular(( /**
             * @return {?}
             */function () {
                _this.polygon = new google.maps.Polygon(_this._combineOptions());
            }));
            this._assertInitialized();
            this.polygon.setMap(this._mapService.getMap());
        };
        /**
         * @private
         * @return {?}
         */
        PolygonDirective.prototype._combineOptions = function () {
            return Object.assign(Object.assign({}, this.options), { draggable: this.draggable || this.options.draggable || false, editable: this.editable || this.options.editable || true, paths: this.paths || this.options.paths, visible: this.visible || this.options.visible || true });
        };
        /**
         * @private
         * @return {?}
         */
        PolygonDirective.prototype._assertInitialized = function () {
            if (!this._mapService.getMap()) {
                throw Error('Cannot access Google Map information before the API has been initialized. ' +
                    'Please wait for the API to load before trying to interact with it.');
            }
            if (!this.polygon) {
                throw Error('Cannot interact with a Google Map Polygon before it has been initialized. ' +
                    'Please wait for the Polygon to load before trying to interact with it.');
            }
        };
        return PolygonDirective;
    }());
    PolygonDirective.decorators = [
        { type: core.Directive, args: [{ selector: '[dgmPolygon]' },] }
    ];
    /** @nocollapse */
    PolygonDirective.ctorParameters = function () { return [
        { type: MapService },
        { type: EventService },
        { type: core.NgZone }
    ]; };
    PolygonDirective.propDecorators = {
        draggable: [{ type: core.Input }],
        editable: [{ type: core.Input }],
        options: [{ type: core.Input }],
        paths: [{ type: core.Input }],
        visible: [{ type: core.Input }],
        polygonClick: [{ type: core.Output }],
        polygonDblclick: [{ type: core.Output }],
        polygonDrag: [{ type: core.Output }],
        polygonDragend: [{ type: core.Output }],
        polygonDragstart: [{ type: core.Output }],
        polygonMousedown: [{ type: core.Output }],
        polygonMousemove: [{ type: core.Output }],
        polygonMouseout: [{ type: core.Output }],
        polygonMouseover: [{ type: core.Output }],
        polygonMouseup: [{ type: core.Output }],
        polygonRightclick: [{ type: core.Output }]
    };
    if (false) {
        /**
         * See https://developers.google.com/maps/documentation/javascript/reference/polygon#PolygonOptions.draggable
         * @type {?}
         */
        PolygonDirective.prototype.draggable;
        /**
         * See https://developers.google.com/maps/documentation/javascript/reference/polygon#PolygonOptions.editable
         * @type {?}
         */
        PolygonDirective.prototype.editable;
        /**
         * See https://developers.google.com/maps/documentation/javascript/reference/polygon#PolygonOptions
         * @type {?}
         */
        PolygonDirective.prototype.options;
        /**
         * See https://developers.google.com/maps/documentation/javascript/reference/polygon#PolygonOptions.paths
         * @type {?}
         */
        PolygonDirective.prototype.paths;
        /**
         * See https://developers.google.com/maps/documentation/javascript/reference/polygon#PolygonOptions.visible
         * @type {?}
         */
        PolygonDirective.prototype.visible;
        /**
         * See https://developers.google.com/maps/documentation/javascript/reference/polygon#Polygon.click
         * @type {?}
         */
        PolygonDirective.prototype.polygonClick;
        /**
         * See https://developers.google.com/maps/documentation/javascript/reference/polygon#Polygon.dblclick
         * @type {?}
         */
        PolygonDirective.prototype.polygonDblclick;
        /**
         * See https://developers.google.com/maps/documentation/javascript/reference/polygon#Polygon.drag
         * @type {?}
         */
        PolygonDirective.prototype.polygonDrag;
        /**
         * See https://developers.google.com/maps/documentation/javascript/reference/polygon#Polygon.dragend
         * @type {?}
         */
        PolygonDirective.prototype.polygonDragend;
        /**
         * See https://developers.google.com/maps/documentation/javascript/reference/polygon#Polygon.dragstart
         * @type {?}
         */
        PolygonDirective.prototype.polygonDragstart;
        /**
         * See https://developers.google.com/maps/documentation/javascript/reference/polygon#Polygon.mousedown
         * @type {?}
         */
        PolygonDirective.prototype.polygonMousedown;
        /**
         * See https://developers.google.com/maps/documentation/javascript/reference/polygon#Polygon.mousemove
         * @type {?}
         */
        PolygonDirective.prototype.polygonMousemove;
        /**
         * See https://developers.google.com/maps/documentation/javascript/reference/polygon#Polygon.mouseout
         * @type {?}
         */
        PolygonDirective.prototype.polygonMouseout;
        /**
         * See https://developers.google.com/maps/documentation/javascript/reference/polygon#Polygon.mouseover
         * @type {?}
         */
        PolygonDirective.prototype.polygonMouseover;
        /**
         * See https://developers.google.com/maps/documentation/javascript/reference/polygon#Polygon.mouseup
         * @type {?}
         */
        PolygonDirective.prototype.polygonMouseup;
        /**
         * See https://developers.google.com/maps/documentation/javascript/reference/polygon#Polygon.rightclick
         * @type {?}
         */
        PolygonDirective.prototype.polygonRightclick;
        /**
         * The underlying google.maps.Polygon object
         *
         * See https://developers.google.com/maps/documentation/javascript/reference/polygon#Polygon
         * @type {?}
         */
        PolygonDirective.prototype.polygon;
        /**
         * @type {?}
         * @private
         */
        PolygonDirective.prototype._destroy$;
        /**
         * @type {?}
         * @private
         */
        PolygonDirective.prototype._mapService;
        /**
         * @type {?}
         * @private
         */
        PolygonDirective.prototype._eventService;
        /**
         * @type {?}
         * @private
         */
        PolygonDirective.prototype._ngZone;
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/directives/polyline/polyline.directive.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Angular directive that renders a Google Maps Polyline via the Google Maps JavaScript API.
     *
     * See developers.google.com/maps/documentation/javascript/reference/polygon#Polyline
     */
    var PolylineDirective = /** @class */ (function () {
        /**
         * @param {?} _mapService
         * @param {?} _eventService
         * @param {?} _ngZone
         */
        function PolylineDirective(_mapService, _eventService, _ngZone) {
            this._mapService = _mapService;
            this._eventService = _eventService;
            this._ngZone = _ngZone;
            /**
             * See https://developers.google.com/maps/documentation/javascript/reference/polygon#Polyline.click
             */
            this.polylineClick = this._eventService.getEventListener('click');
            /**
             * See https://developers.google.com/maps/documentation/javascript/reference/polygon#Polyline.dblclick
             */
            this.polylineDblclick = this._eventService.getEventListener('dblclick');
            /**
             * See https://developers.google.com/maps/documentation/javascript/reference/polygon#Polyline.drag
             */
            this.polylineDrag = this._eventService.getEventListener('drag');
            /**
             * See https://developers.google.com/maps/documentation/javascript/reference/polygon#Polyline.dragend
             */
            this.polylineDragend = this._eventService.getEventListener('dragend');
            /**
             * See https://developers.google.com/maps/documentation/javascript/reference/polygon#Polyline.dragstart
             */
            this.polylineDragstart = this._eventService.getEventListener('dragstart');
            /**
             * See https://developers.google.com/maps/documentation/javascript/reference/polygon#Polyline.mousedown
             */
            this.polylineMousedown = this._eventService.getEventListener('mousedown');
            /**
             * See https://developers.google.com/maps/documentation/javascript/reference/polygon#Polyline.mousemove
             */
            this.polylineMousemove = this._eventService.getEventListener('mousemove');
            /**
             * See https://developers.google.com/maps/documentation/javascript/reference/polygon#Polyline.mouseout
             */
            this.polylineMouseout = this._eventService.getEventListener('mouseout');
            /**
             * See https://developers.google.com/maps/documentation/javascript/reference/polygon#Polyline.mouseover
             */
            this.polylineMouseover = this._eventService.getEventListener('mouseover');
            /**
             * See https://developers.google.com/maps/documentation/javascript/reference/polygon#Polyline.mouseup
             */
            this.polylineMouseup = this._eventService.getEventListener('mouseup');
            /**
             * See https://developers.google.com/maps/documentation/javascript/reference/polygon#Polyline.rightclick
             */
            this.polylineRightclick = this._eventService.getEventListener('rightclick');
            this._destroy$ = new rxjs.Subject();
        }
        /**
         * @return {?}
         */
        PolylineDirective.prototype.ngOnInit = function () {
            var _this = this;
            this._mapService.load$
                .pipe(operators.filter(Boolean), operators.takeUntil(this._destroy$))
                .subscribe(( /**
         * @return {?}
         */function () {
                _this._onInit();
            }));
        };
        /**
         * @param {?} changes
         * @return {?}
         */
        PolylineDirective.prototype.ngOnChanges = function (changes) {
            if (!this.polyline) {
                return;
            }
            changes.draggable
                && !changes.draggable.isFirstChange()
                && this.polyline.setDraggable(this.draggable);
            changes.editable
                && !changes.editable.isFirstChange()
                && this.polyline.setEditable(this.editable);
            changes.options
                && !changes.options.isFirstChange()
                && this.polyline.setOptions(this._combineOptions());
            changes.path
                && !changes.path.isFirstChange()
                && this.polyline.setPath(this.path);
            changes.visible
                && !changes.visible.isFirstChange()
                && this.polyline.setVisible(this.visible);
        };
        /**
         * @return {?}
         */
        PolylineDirective.prototype.ngOnDestroy = function () {
            this._destroy$.next();
            this._destroy$.complete();
            this.polyline && this.polyline.setMap(null);
        };
        /**
         * @private
         * @return {?}
         */
        PolylineDirective.prototype._onInit = function () {
            var _this = this;
            this._ngZone.runOutsideAngular(( /**
             * @return {?}
             */function () {
                _this.polyline = new google.maps.Polyline(_this._combineOptions());
            }));
            this._assertInitialized();
            this.polyline.setMap(this._mapService.getMap());
        };
        /**
         * @private
         * @return {?}
         */
        PolylineDirective.prototype._combineOptions = function () {
            return Object.assign(Object.assign({}, this.options), { visible: this.visible || this.options.visible || true, path: this.path || this.options.path, editable: this.editable || this.options.editable || true, draggable: this.draggable || this.options.draggable || false });
        };
        /**
         * @private
         * @return {?}
         */
        PolylineDirective.prototype._assertInitialized = function () {
            if (!this._mapService.getMap()) {
                throw Error('Cannot access Google Map information before the API has been initialized. ' +
                    'Please wait for the API to load before trying to interact with it.');
            }
            if (!this.polyline) {
                throw Error('Cannot interact with a Google Map Polyline before it has been initialized. ' +
                    'Please wait for the Polyline to load before trying to interact with it.');
            }
        };
        return PolylineDirective;
    }());
    PolylineDirective.decorators = [
        { type: core.Directive, args: [{ selector: '[dgmPolyline]' },] }
    ];
    /** @nocollapse */
    PolylineDirective.ctorParameters = function () { return [
        { type: MapService },
        { type: EventService },
        { type: core.NgZone }
    ]; };
    PolylineDirective.propDecorators = {
        draggable: [{ type: core.Input }],
        editable: [{ type: core.Input }],
        options: [{ type: core.Input }],
        path: [{ type: core.Input }],
        visible: [{ type: core.Input }],
        polylineClick: [{ type: core.Output }],
        polylineDblclick: [{ type: core.Output }],
        polylineDrag: [{ type: core.Output }],
        polylineDragend: [{ type: core.Output }],
        polylineDragstart: [{ type: core.Output }],
        polylineMousedown: [{ type: core.Output }],
        polylineMousemove: [{ type: core.Output }],
        polylineMouseout: [{ type: core.Output }],
        polylineMouseover: [{ type: core.Output }],
        polylineMouseup: [{ type: core.Output }],
        polylineRightclick: [{ type: core.Output }]
    };
    if (false) {
        /**
         * See https://developers.google.com/maps/documentation/javascript/reference/polygon#PolylineOptions.draggable
         * @type {?}
         */
        PolylineDirective.prototype.draggable;
        /**
         * See https://developers.google.com/maps/documentation/javascript/reference/polygon#PolylineOptions.editable
         * @type {?}
         */
        PolylineDirective.prototype.editable;
        /**
         * See https://developers.google.com/maps/documentation/javascript/reference/polygon#PolylineOptions
         * @type {?}
         */
        PolylineDirective.prototype.options;
        /**
         * See https://developers.google.com/maps/documentation/javascript/reference/polygon#PolylineOptions.path
         * @type {?}
         */
        PolylineDirective.prototype.path;
        /**
         * See https://developers.google.com/maps/documentation/javascript/reference/polygon#PolylineOptions.visible
         * @type {?}
         */
        PolylineDirective.prototype.visible;
        /**
         * See https://developers.google.com/maps/documentation/javascript/reference/polygon#Polyline.click
         * @type {?}
         */
        PolylineDirective.prototype.polylineClick;
        /**
         * See https://developers.google.com/maps/documentation/javascript/reference/polygon#Polyline.dblclick
         * @type {?}
         */
        PolylineDirective.prototype.polylineDblclick;
        /**
         * See https://developers.google.com/maps/documentation/javascript/reference/polygon#Polyline.drag
         * @type {?}
         */
        PolylineDirective.prototype.polylineDrag;
        /**
         * See https://developers.google.com/maps/documentation/javascript/reference/polygon#Polyline.dragend
         * @type {?}
         */
        PolylineDirective.prototype.polylineDragend;
        /**
         * See https://developers.google.com/maps/documentation/javascript/reference/polygon#Polyline.dragstart
         * @type {?}
         */
        PolylineDirective.prototype.polylineDragstart;
        /**
         * See https://developers.google.com/maps/documentation/javascript/reference/polygon#Polyline.mousedown
         * @type {?}
         */
        PolylineDirective.prototype.polylineMousedown;
        /**
         * See https://developers.google.com/maps/documentation/javascript/reference/polygon#Polyline.mousemove
         * @type {?}
         */
        PolylineDirective.prototype.polylineMousemove;
        /**
         * See https://developers.google.com/maps/documentation/javascript/reference/polygon#Polyline.mouseout
         * @type {?}
         */
        PolylineDirective.prototype.polylineMouseout;
        /**
         * See https://developers.google.com/maps/documentation/javascript/reference/polygon#Polyline.mouseover
         * @type {?}
         */
        PolylineDirective.prototype.polylineMouseover;
        /**
         * See https://developers.google.com/maps/documentation/javascript/reference/polygon#Polyline.mouseup
         * @type {?}
         */
        PolylineDirective.prototype.polylineMouseup;
        /**
         * See https://developers.google.com/maps/documentation/javascript/reference/polygon#Polyline.rightclick
         * @type {?}
         */
        PolylineDirective.prototype.polylineRightclick;
        /**
         * The underlying google.maps.Polyline object
         *
         * See https://developers.google.com/maps/documentation/javascript/reference/polygon#Polyline
         * @type {?}
         */
        PolylineDirective.prototype.polyline;
        /**
         * @type {?}
         * @private
         */
        PolylineDirective.prototype._destroy$;
        /**
         * @type {?}
         * @private
         */
        PolylineDirective.prototype._mapService;
        /**
         * @type {?}
         * @private
         */
        PolylineDirective.prototype._eventService;
        /**
         * @type {?}
         * @private
         */
        PolylineDirective.prototype._ngZone;
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/directives/rectangle/rectangle.directive.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Angular directive that renders a Google Maps Rectangle via the Google Maps JavaScript API.
     *
     * See developers.google.com/maps/documentation/javascript/reference/polygon#Rectangle
     */
    var RectangleDirective = /** @class */ (function () {
        /**
         * @param {?} _mapService
         * @param {?} _eventService
         * @param {?} _ngZone
         */
        function RectangleDirective(_mapService, _eventService, _ngZone) {
            this._mapService = _mapService;
            this._eventService = _eventService;
            this._ngZone = _ngZone;
            /**
             * See https://developers.google.com/maps/documentation/javascript/reference/polygon#Rectangle.boundsChanged
             */
            this.boundsChanged = this._eventService.getEventListener('bounds_changed');
            /**
             * See https://developers.google.com/maps/documentation/javascript/reference/polygon#Rectangle.click
             */
            this.rectangleClick = this._eventService.getEventListener('click');
            /**
             * See https://developers.google.com/maps/documentation/javascript/reference/polygon#Rectangle.dblclick
             */
            this.rectangleDblclick = this._eventService.getEventListener('dblclick');
            /**
             * See https://developers.google.com/maps/documentation/javascript/reference/polygon#Rectangle.drag
             */
            this.rectangleDrag = this._eventService.getEventListener('drag');
            /**
             * See https://developers.google.com/maps/documentation/javascript/reference/polygon#Rectangle.dragend
             */
            this.rectangleDragend = this._eventService.getEventListener('dragend');
            /**
             * See https://developers.google.com/maps/documentation/javascript/reference/polygon#Rectangle.dragstart
             */
            this.rectangleDragstart = this._eventService.getEventListener('dragstart');
            /**
             * See https://developers.google.com/maps/documentation/javascript/reference/polygon#Rectangle.mousedown
             */
            this.rectangleMousedown = this._eventService.getEventListener('mousedown');
            /**
             * See https://developers.google.com/maps/documentation/javascript/reference/polygon#Rectangle.mousemove
             */
            this.rectangleMousemove = this._eventService.getEventListener('mousemove');
            /**
             * See https://developers.google.com/maps/documentation/javascript/reference/polygon#Rectangle.mouseout
             */
            this.rectangleMouseout = this._eventService.getEventListener('mouseout');
            /**
             * See https://developers.google.com/maps/documentation/javascript/reference/polygon#Rectangle.mouseover
             */
            this.rectangleMouseover = this._eventService.getEventListener('mouseover');
            /**
             * See https://developers.google.com/maps/documentation/javascript/reference/polygon#Rectangle.mouseup
             */
            this.rectangleMouseup = this._eventService.getEventListener('mouseup');
            /**
             * See https://developers.google.com/maps/documentation/javascript/reference/polygon#Rectangle.rightclick
             */
            this.rectangleRightclick = this._eventService.getEventListener('rightclick');
            this._destroy$ = new rxjs.Subject();
        }
        /**
         * @return {?}
         */
        RectangleDirective.prototype.ngOnInit = function () {
            var _this = this;
            this._mapService.load$
                .pipe(operators.filter(Boolean), operators.takeUntil(this._destroy$))
                .subscribe(( /**
         * @return {?}
         */function () {
                _this._onInit();
            }));
        };
        /**
         * @param {?} changes
         * @return {?}
         */
        RectangleDirective.prototype.ngOnChanges = function (changes) {
            if (!this.restangle) {
                return;
            }
            changes.bounds
                && !changes.bounds.isFirstChange()
                && this.restangle.setBounds(this.bounds);
            changes.draggable
                && !changes.draggable.isFirstChange()
                && this.restangle.setDraggable(this.draggable);
            changes.editable
                && !changes.editable.isFirstChange()
                && this.restangle.setEditable(this.editable);
            changes.options
                && !changes.options.isFirstChange()
                && this.restangle.setOptions(this._combineOptions());
            changes.visible
                && !changes.visible.isFirstChange()
                && this.restangle.setVisible(this.visible);
        };
        /**
         * @return {?}
         */
        RectangleDirective.prototype.ngOnDestroy = function () {
            this._destroy$.next();
            this._destroy$.complete();
            this.restangle && this.restangle.setMap(null);
        };
        /**
         * @private
         * @return {?}
         */
        RectangleDirective.prototype._onInit = function () {
            var _this = this;
            this._ngZone.runOutsideAngular(( /**
             * @return {?}
             */function () {
                _this.restangle = new google.maps.Rectangle(_this._combineOptions());
            }));
            this._assertInitialized();
            this.restangle.setMap(this._mapService.getMap());
        };
        /**
         * @private
         * @return {?}
         */
        RectangleDirective.prototype._combineOptions = function () {
            return Object.assign(Object.assign({}, this.options), { visible: this.visible || this.options.visible || true, bounds: this.bounds || this.options.bounds, editable: this.editable || this.options.editable || true, draggable: this.draggable || this.options.draggable || false });
        };
        /**
         * @private
         * @return {?}
         */
        RectangleDirective.prototype._assertInitialized = function () {
            if (!this._mapService.getMap()) {
                throw Error('Cannot access Google Map information before the API has been initialized. ' +
                    'Please wait for the API to load before trying to interact with it.');
            }
            if (!this.restangle) {
                throw Error('Cannot interact with a Google Map Rectangle before it has been initialized. ' +
                    'Please wait for the Rectangle to load before trying to interact with it.');
            }
        };
        return RectangleDirective;
    }());
    RectangleDirective.decorators = [
        { type: core.Directive, args: [{ selector: '[dgmRectangle]' },] }
    ];
    /** @nocollapse */
    RectangleDirective.ctorParameters = function () { return [
        { type: MapService },
        { type: EventService },
        { type: core.NgZone }
    ]; };
    RectangleDirective.propDecorators = {
        bounds: [{ type: core.Input }],
        draggable: [{ type: core.Input }],
        editable: [{ type: core.Input }],
        options: [{ type: core.Input }],
        visible: [{ type: core.Input }],
        boundsChanged: [{ type: core.Output }],
        rectangleClick: [{ type: core.Output }],
        rectangleDblclick: [{ type: core.Output }],
        rectangleDrag: [{ type: core.Output }],
        rectangleDragend: [{ type: core.Output }],
        rectangleDragstart: [{ type: core.Output }],
        rectangleMousedown: [{ type: core.Output }],
        rectangleMousemove: [{ type: core.Output }],
        rectangleMouseout: [{ type: core.Output }],
        rectangleMouseover: [{ type: core.Output }],
        rectangleMouseup: [{ type: core.Output }],
        rectangleRightclick: [{ type: core.Output }]
    };
    if (false) {
        /**
         * See https://developers.google.com/maps/documentation/javascript/reference/polygon#RectangleOptions.bounds
         * @type {?}
         */
        RectangleDirective.prototype.bounds;
        /**
         * See https://developers.google.com/maps/documentation/javascript/reference/polygon#RectangleOptions.draggable
         * @type {?}
         */
        RectangleDirective.prototype.draggable;
        /**
         * See https://developers.google.com/maps/documentation/javascript/reference/polygon#RectangleOptions.editable
         * @type {?}
         */
        RectangleDirective.prototype.editable;
        /**
         * See https://developers.google.com/maps/documentation/javascript/reference/polygon#RectangleOptions
         * @type {?}
         */
        RectangleDirective.prototype.options;
        /**
         * See https://developers.google.com/maps/documentation/javascript/reference/polygon#RectangleOptions.visible
         * @type {?}
         */
        RectangleDirective.prototype.visible;
        /**
         * See https://developers.google.com/maps/documentation/javascript/reference/polygon#Rectangle.boundsChanged
         * @type {?}
         */
        RectangleDirective.prototype.boundsChanged;
        /**
         * See https://developers.google.com/maps/documentation/javascript/reference/polygon#Rectangle.click
         * @type {?}
         */
        RectangleDirective.prototype.rectangleClick;
        /**
         * See https://developers.google.com/maps/documentation/javascript/reference/polygon#Rectangle.dblclick
         * @type {?}
         */
        RectangleDirective.prototype.rectangleDblclick;
        /**
         * See https://developers.google.com/maps/documentation/javascript/reference/polygon#Rectangle.drag
         * @type {?}
         */
        RectangleDirective.prototype.rectangleDrag;
        /**
         * See https://developers.google.com/maps/documentation/javascript/reference/polygon#Rectangle.dragend
         * @type {?}
         */
        RectangleDirective.prototype.rectangleDragend;
        /**
         * See https://developers.google.com/maps/documentation/javascript/reference/polygon#Rectangle.dragstart
         * @type {?}
         */
        RectangleDirective.prototype.rectangleDragstart;
        /**
         * See https://developers.google.com/maps/documentation/javascript/reference/polygon#Rectangle.mousedown
         * @type {?}
         */
        RectangleDirective.prototype.rectangleMousedown;
        /**
         * See https://developers.google.com/maps/documentation/javascript/reference/polygon#Rectangle.mousemove
         * @type {?}
         */
        RectangleDirective.prototype.rectangleMousemove;
        /**
         * See https://developers.google.com/maps/documentation/javascript/reference/polygon#Rectangle.mouseout
         * @type {?}
         */
        RectangleDirective.prototype.rectangleMouseout;
        /**
         * See https://developers.google.com/maps/documentation/javascript/reference/polygon#Rectangle.mouseover
         * @type {?}
         */
        RectangleDirective.prototype.rectangleMouseover;
        /**
         * See https://developers.google.com/maps/documentation/javascript/reference/polygon#Rectangle.mouseup
         * @type {?}
         */
        RectangleDirective.prototype.rectangleMouseup;
        /**
         * See https://developers.google.com/maps/documentation/javascript/reference/polygon#Rectangle.rightclick
         * @type {?}
         */
        RectangleDirective.prototype.rectangleRightclick;
        /**
         * The underlying google.maps.Rectangle object
         *
         * See https://developers.google.com/maps/documentation/javascript/reference/polygon#Rectangle
         * @type {?}
         */
        RectangleDirective.prototype.restangle;
        /**
         * @type {?}
         * @private
         */
        RectangleDirective.prototype._destroy$;
        /**
         * @type {?}
         * @private
         */
        RectangleDirective.prototype._mapService;
        /**
         * @type {?}
         * @private
         */
        RectangleDirective.prototype._eventService;
        /**
         * @type {?}
         * @private
         */
        RectangleDirective.prototype._ngZone;
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/directives/traffic-layer/traffic-layer.directive.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Angular directive that renders a Google Maps Traffic Layer via the Google Maps JavaScript API.
     *
     * See https://developers.google.com/maps/documentation/javascript/reference/map#TrafficLayer
     */
    var TrafficLayerDirective = /** @class */ (function () {
        /**
         * @param {?} _mapService
         * @param {?} _ngZone
         */
        function TrafficLayerDirective(_mapService, _ngZone) {
            this._mapService = _mapService;
            this._ngZone = _ngZone;
            this._destroy$ = new rxjs.Subject();
        }
        /**
         * @return {?}
         */
        TrafficLayerDirective.prototype.ngOnInit = function () {
            var _this = this;
            this._mapService.load$
                .pipe(operators.filter(Boolean), operators.takeUntil(this._destroy$))
                .subscribe(( /**
         * @return {?}
         */function () {
                _this._onInit();
            }));
        };
        /**
         * @param {?} changes
         * @return {?}
         */
        TrafficLayerDirective.prototype.ngOnChanges = function (changes) {
            changes.autoRefresh
                && !changes.autoRefresh.isFirstChange()
                && this.trafficLayer.setOptions(this._combineOptions());
        };
        /**
         * @return {?}
         */
        TrafficLayerDirective.prototype.ngOnDestroy = function () {
            this._destroy$.next();
            this._destroy$.complete();
            this.trafficLayer && this.trafficLayer.setMap(null);
        };
        /**
         * @private
         * @return {?}
         */
        TrafficLayerDirective.prototype._onInit = function () {
            var _this = this;
            this._ngZone.runOutsideAngular(( /**
             * @return {?}
             */function () {
                _this.trafficLayer = new google.maps.TrafficLayer(_this._combineOptions());
            }));
            this._assertInitialized();
            this.trafficLayer.setMap(this._mapService.getMap());
        };
        /**
         * @private
         * @return {?}
         */
        TrafficLayerDirective.prototype._combineOptions = function () {
            return { autoRefresh: this.autoRefresh };
        };
        /**
         * @private
         * @return {?}
         */
        TrafficLayerDirective.prototype._assertInitialized = function () {
            if (!this._mapService.getMap()) {
                throw Error('Cannot access Google Map information before the API has been initialized. ' +
                    'Please wait for the API to load before trying to interact with it.');
            }
            if (!this.trafficLayer) {
                throw Error('Cannot interact with a Google Map Traffic Layer before it has been initialized. ' +
                    'Please wait for the Traffic Layer to load before trying to interact with it.');
            }
        };
        return TrafficLayerDirective;
    }());
    TrafficLayerDirective.decorators = [
        { type: core.Directive, args: [{ selector: '[dgmTrafficLayer]' },] }
    ];
    /** @nocollapse */
    TrafficLayerDirective.ctorParameters = function () { return [
        { type: MapService },
        { type: core.NgZone }
    ]; };
    TrafficLayerDirective.propDecorators = {
        autoRefresh: [{ type: core.Input }]
    };
    if (false) {
        /**
         * See https://developers.google.com/maps/documentation/javascript/reference/map#TrafficLayerOptions.autoRefresh
         * @type {?}
         */
        TrafficLayerDirective.prototype.autoRefresh;
        /**
         * The underlying google.maps.TrafficLayer object
         *
         * See https://developers.google.com/maps/documentation/javascript/reference/map#TrafficLayer
         * @type {?}
         */
        TrafficLayerDirective.prototype.trafficLayer;
        /**
         * @type {?}
         * @private
         */
        TrafficLayerDirective.prototype._destroy$;
        /**
         * @type {?}
         * @private
         */
        TrafficLayerDirective.prototype._mapService;
        /**
         * @type {?}
         * @private
         */
        TrafficLayerDirective.prototype._ngZone;
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/directives/transit-layer/transit-layer.directive.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Angular directive that renders a Google Maps Traffic Layer via the Google Maps JavaScript API.
     *
     * See https://developers.google.com/maps/documentation/javascript/reference/map#TransitLayer
     */
    var TransitLayerDirective = /** @class */ (function () {
        /**
         * @param {?} _mapService
         */
        function TransitLayerDirective(_mapService) {
            this._mapService = _mapService;
            this._destroy$ = new rxjs.Subject();
        }
        /**
         * @return {?}
         */
        TransitLayerDirective.prototype.ngOnInit = function () {
            var _this = this;
            this._mapService.load$
                .pipe(operators.filter(Boolean), operators.takeUntil(this._destroy$))
                .subscribe(( /**
         * @return {?}
         */function () {
                _this._onInit();
            }));
        };
        /**
         * @return {?}
         */
        TransitLayerDirective.prototype.ngOnDestroy = function () {
            this._destroy$.next();
            this._destroy$.complete();
            this.transitLayer && this.transitLayer.setMap(null);
        };
        /**
         * @private
         * @return {?}
         */
        TransitLayerDirective.prototype._onInit = function () {
            this.transitLayer = new google.maps.TransitLayer();
            this._assertInitialized();
            this.transitLayer.setMap(this._mapService.getMap());
        };
        /**
         * @private
         * @return {?}
         */
        TransitLayerDirective.prototype._assertInitialized = function () {
            if (!this._mapService.getMap()) {
                throw Error('Cannot access Google Map information before the API has been initialized. ' +
                    'Please wait for the API to load before trying to interact with it.');
            }
            if (!this.transitLayer) {
                throw Error('Cannot interact with a Google Map Traffic Layer before it has been initialized. ' +
                    'Please wait for the Traffic Layer to load before trying to interact with it.');
            }
        };
        return TransitLayerDirective;
    }());
    TransitLayerDirective.decorators = [
        { type: core.Directive, args: [{ selector: '[dgmTransitLayer]' },] }
    ];
    /** @nocollapse */
    TransitLayerDirective.ctorParameters = function () { return [
        { type: MapService }
    ]; };
    if (false) {
        /**
         * The underlying google.maps.TransitLayer object
         *
         * See https://developers.google.com/maps/documentation/javascript/reference/map#TransitLayer
         * @type {?}
         */
        TransitLayerDirective.prototype.transitLayer;
        /**
         * @type {?}
         * @private
         */
        TransitLayerDirective.prototype._destroy$;
        /**
         * @type {?}
         * @private
         */
        TransitLayerDirective.prototype._mapService;
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/directives/index.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/enums/script-protocol.enums.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @enum {number} */
    var ScriptProtocol = {
        HTTP: 0,
        HTTPS: 1,
        AUTO: 2,
    };
    ScriptProtocol[ScriptProtocol.HTTP] = 'HTTP';
    ScriptProtocol[ScriptProtocol.HTTPS] = 'HTTPS';
    ScriptProtocol[ScriptProtocol.AUTO] = 'AUTO';

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/enums/index.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/models/api-config.model.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var APIConfig = /** @class */ (function () {
        function APIConfig() {
        }
        return APIConfig;
    }());

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/models/index.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */
    /* global Reflect, Promise */
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b)
                if (Object.prototype.hasOwnProperty.call(b, p))
                    d[p] = b[p]; };
        return extendStatics(d, b);
    };
    function __extends(d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }
    var __assign = function () {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s)
                    if (Object.prototype.hasOwnProperty.call(s, p))
                        t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };
    function __rest(s, e) {
        var t = {};
        for (var p in s)
            if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
                t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }
    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
            r = Reflect.decorate(decorators, target, key, desc);
        else
            for (var i = decorators.length - 1; i >= 0; i--)
                if (d = decorators[i])
                    r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }
    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); };
    }
    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function")
            return Reflect.metadata(metadataKey, metadataValue);
    }
    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try {
                step(generator.next(value));
            }
            catch (e) {
                reject(e);
            } }
            function rejected(value) { try {
                step(generator["throw"](value));
            }
            catch (e) {
                reject(e);
            } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }
    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function () { if (t[0] & 1)
                throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function () { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f)
                throw new TypeError("Generator is already executing.");
            while (_)
                try {
                    if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done)
                        return t;
                    if (y = 0, t)
                        op = [op[0] & 2, t.value];
                    switch (op[0]) {
                        case 0:
                        case 1:
                            t = op;
                            break;
                        case 4:
                            _.label++;
                            return { value: op[1], done: false };
                        case 5:
                            _.label++;
                            y = op[1];
                            op = [0];
                            continue;
                        case 7:
                            op = _.ops.pop();
                            _.trys.pop();
                            continue;
                        default:
                            if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) {
                                _ = 0;
                                continue;
                            }
                            if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) {
                                _.label = op[1];
                                break;
                            }
                            if (op[0] === 6 && _.label < t[1]) {
                                _.label = t[1];
                                t = op;
                                break;
                            }
                            if (t && _.label < t[2]) {
                                _.label = t[2];
                                _.ops.push(op);
                                break;
                            }
                            if (t[2])
                                _.ops.pop();
                            _.trys.pop();
                            continue;
                    }
                    op = body.call(thisArg, _);
                }
                catch (e) {
                    op = [6, e];
                    y = 0;
                }
                finally {
                    f = t = 0;
                }
            if (op[0] & 5)
                throw op[1];
            return { value: op[0] ? op[1] : void 0, done: true };
        }
    }
    var __createBinding = Object.create ? (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        Object.defineProperty(o, k2, { enumerable: true, get: function () { return m[k]; } });
    }) : (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        o[k2] = m[k];
    });
    function __exportStar(m, o) {
        for (var p in m)
            if (p !== "default" && !Object.prototype.hasOwnProperty.call(o, p))
                __createBinding(o, m, p);
    }
    function __values(o) {
        var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
        if (m)
            return m.call(o);
        if (o && typeof o.length === "number")
            return {
                next: function () {
                    if (o && i >= o.length)
                        o = void 0;
                    return { value: o && o[i++], done: !o };
                }
            };
        throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
    }
    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m)
            return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done)
                ar.push(r.value);
        }
        catch (error) {
            e = { error: error };
        }
        finally {
            try {
                if (r && !r.done && (m = i["return"]))
                    m.call(i);
            }
            finally {
                if (e)
                    throw e.error;
            }
        }
        return ar;
    }
    /** @deprecated */
    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }
    /** @deprecated */
    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++)
            s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    }
    function __spreadArray(to, from) {
        for (var i = 0, il = from.length, j = to.length; i < il; i++, j++)
            to[j] = from[i];
        return to;
    }
    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }
    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n])
            i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try {
            step(g[n](v));
        }
        catch (e) {
            settle(q[0][3], e);
        } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length)
            resume(q[0][0], q[0][1]); }
    }
    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }
    function __asyncValues(o) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function (v) { resolve({ value: v, done: d }); }, reject); }
    }
    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) {
            Object.defineProperty(cooked, "raw", { value: raw });
        }
        else {
            cooked.raw = raw;
        }
        return cooked;
    }
    ;
    var __setModuleDefault = Object.create ? (function (o, v) {
        Object.defineProperty(o, "default", { enumerable: true, value: v });
    }) : function (o, v) {
        o["default"] = v;
    };
    function __importStar(mod) {
        if (mod && mod.__esModule)
            return mod;
        var result = {};
        if (mod != null)
            for (var k in mod)
                if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k))
                    __createBinding(result, mod, k);
        __setModuleDefault(result, mod);
        return result;
    }
    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }
    function __classPrivateFieldGet(receiver, privateMap) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to get private field on non-instance");
        }
        return privateMap.get(receiver);
    }
    function __classPrivateFieldSet(receiver, privateMap, value) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to set private field on non-instance");
        }
        privateMap.set(receiver, value);
        return value;
    }

    var LazyMapsAPILoader = /** @class */ (function (_super) {
        __extends(LazyMapsAPILoader, _super);
        /**
         * @param {?} _config
         * @param {?} _windowRef
         * @param {?} _documentRef
         * @param {?} _localeId
         */
        function LazyMapsAPILoader(_config, _windowRef, _documentRef, _localeId) {
            var _this = _super.call(this) || this;
            _this._config = _config;
            _this._windowRef = _windowRef;
            _this._documentRef = _documentRef;
            _this._localeId = _localeId;
            return _this;
        }
        /**
         * @return {?}
         */
        LazyMapsAPILoader.prototype.load = function () {
            var _this = this;
            /** @type {?} */
            var window = ( /** @type {?} */(( /** @type {?} */(this._windowRef.getNativeWindow()))));
            if (window.google && window.google.maps) {
                this._scriptLoading$ = new rxjs.ReplaySubject(1);
                this._scriptLoading$.next();
                this._scriptLoading$.complete();
                return this._scriptLoading$;
            }
            if (this._scriptLoading$) {
                return this._scriptLoading$;
            }
            /** @type {?} */
            var script = this._createElementScript();
            /** @type {?} */
            var callbackName = 'Create';
            script.src = this._getMapsScriptSrc(callbackName);
            this._scriptLoading$ = new rxjs.ReplaySubject(1);
            this._windowRef.getNativeWindow()[callbackName] = ( /**
             * @return {?}
             */function () {
                _this._scriptLoading$.next();
                _this._scriptLoading$.complete();
            });
            script.onerror = ( /**
             * @param {?} error
             * @return {?}
             */function (error) { _this._scriptLoading$.error(error); });
            this._documentRef.getNativeDocument().head.appendChild(script);
            return this._scriptLoading$;
        };
        /**
         * @private
         * @return {?}
         */
        LazyMapsAPILoader.prototype._createElementScript = function () {
            /** @type {?} */
            var script = this._documentRef.getNativeDocument().createElement('script');
            script.type = 'text/javascript';
            script.async = true;
            script.defer = true;
            return script;
        };
        /**
         * @private
         * @param {?} callbackName
         * @return {?}
         */
        LazyMapsAPILoader.prototype._getMapsScriptSrc = function (callbackName) {
            return this._getScriptSrc(this._getScriptUrl(), this._getQueryParams(callbackName));
        };
        /**
         * @private
         * @param {?} hostAndPath
         * @param {?} queryParams
         * @return {?}
         */
        LazyMapsAPILoader.prototype._getScriptSrc = function (hostAndPath, queryParams) {
            /** @type {?} */
            var protocolType = ( /** @type {?} */(((this._config && this._config.protocol) || ScriptProtocol.HTTPS)));
            /** @type {?} */
            var protocol = this._getProtocol(protocolType);
            /** @type {?} */
            var params = this._getParams(queryParams);
            return protocol + "//" + hostAndPath + "?" + params;
        };
        /**
         * @private
         * @param {?} protocolType
         * @return {?}
         */
        LazyMapsAPILoader.prototype._getProtocol = function (protocolType) {
            switch (protocolType) {
                case ScriptProtocol.AUTO:
                    return '';
                case ScriptProtocol.HTTP:
                    return 'http:';
                case ScriptProtocol.HTTPS:
                    return 'https:';
            }
        };
        /**
         * @private
         * @param {?} queryParams
         * @return {?}
         */
        LazyMapsAPILoader.prototype._getParams = function (queryParams) {
            return Object.keys(queryParams)
                .filter(( /**
         * @param {?} k
         * @return {?}
         */function (k) { return queryParams[k] != null; }))
                .filter(( /**
         * @param {?} k
         * @return {?}
         */function (k) {
                return !Array.isArray(queryParams[k]) ||
                    (Array.isArray(queryParams[k]) && queryParams[k].length > 0);
            }))
                .map(( /**
         * @param {?} k
         * @return {?}
         */function (k) {
                /** @type {?} */
                var i = queryParams[k];
                return Array.isArray(i) ? { key: k, value: i.join(',') }
                    : { key: k, value: queryParams[k] };
            }))
                .map(( /**
         * @param {?} entry
         * @return {?}
         */function (entry) { return entry.key + "=" + entry.value; }))
                .join('&');
        };
        /**
         * @private
         * @return {?}
         */
        LazyMapsAPILoader.prototype._getScriptUrl = function () {
            return this._config.hostAndPath
                || 'maps.googleapis.com/maps/api/js';
        };
        /**
         * @private
         * @param {?} callbackName
         * @return {?}
         */
        LazyMapsAPILoader.prototype._getQueryParams = function (callbackName) {
            return {
                version: this._config.apiVersion || 'quarterly',
                callback: callbackName,
                key: this._config.apiKey,
                client: this._config.clientId,
                channel: this._config.channel,
                libraries: this._config.libraries,
                region: this._config.region,
                language: this._config.language || (this._localeId !== 'en-US' ? this._localeId : null),
            };
        };
        return LazyMapsAPILoader;
    }(MapsAPILoader));
    LazyMapsAPILoader.decorators = [
        { type: core.Injectable }
    ];
    /** @nocollapse */
    LazyMapsAPILoader.ctorParameters = function () { return [
        { type: undefined, decorators: [{ type: core.Optional }, { type: core.Inject, args: [API_CONFIG,] }] },
        { type: WindowRef },
        { type: DocumentRef },
        { type: String, decorators: [{ type: core.Inject, args: [core.LOCALE_ID,] }] }
    ]; };
    if (false) {
        /**
         * @type {?}
         * @private
         */
        LazyMapsAPILoader.prototype._scriptLoading$;
        /**
         * @type {?}
         * @private
         */
        LazyMapsAPILoader.prototype._config;
        /**
         * @type {?}
         * @private
         */
        LazyMapsAPILoader.prototype._windowRef;
        /**
         * @type {?}
         * @private
         */
        LazyMapsAPILoader.prototype._documentRef;
        /**
         * @type {?}
         * @private
         */
        LazyMapsAPILoader.prototype._localeId;
    }

    /**
     * @return {?}
     */
    function mapsComponents() {
        return [
            BicyclingLayerDirective,
            CircleDirective,
            FitBoundsDirective,
            GroundOverlayDirective,
            KmlLayerDirective,
            MarkerDirective,
            MapComponent,
            PolygonDirective,
            PolylineDirective,
            RectangleDirective,
            TrafficLayerDirective,
            TransitLayerDirective,
        ];
    }
    var DgmMapsModule = /** @class */ (function () {
        function DgmMapsModule() {
        }
        /**
         * @param {?=} APILoaderConfig
         * @return {?}
         */
        DgmMapsModule.forRoot = function (APILoaderConfig) {
            return {
                ngModule: DgmMapsModule,
                providers: __spread(BROWSER_PROVIDERS, [
                    { provide: MapsAPILoader, useClass: LazyMapsAPILoader },
                    { provide: API_CONFIG, useValue: APILoaderConfig },
                ]),
            };
        };
        return DgmMapsModule;
    }());
    DgmMapsModule.decorators = [
        { type: core.NgModule, args: [{
                    imports: [
                        common.CommonModule,
                    ], declarations: mapsComponents(), exports: mapsComponents(),
                },] }
    ];

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/services/index.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * Generated from: public-api.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * Generated from: dxgm-maps.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    exports.APIConfig = APIConfig;
    exports.API_CONFIG = API_CONFIG;
    exports.BROWSER_PROVIDERS = BROWSER_PROVIDERS;
    exports.BicyclingLayerDirective = BicyclingLayerDirective;
    exports.CircleDirective = CircleDirective;
    exports.DgmMapsModule = DgmMapsModule;
    exports.DocumentRef = DocumentRef;
    exports.EventService = EventService;
    exports.FitBoundsAccessor = FitBoundsAccessor;
    exports.FitBoundsDirective = FitBoundsDirective;
    exports.FitBoundsService = FitBoundsService;
    exports.GroundOverlayDirective = GroundOverlayDirective;
    exports.KmlLayerDirective = KmlLayerDirective;
    exports.LazyMapsAPILoader = LazyMapsAPILoader;
    exports.MapComponent = MapComponent;
    exports.MapService = MapService;
    exports.MapsAPILoader = MapsAPILoader;
    exports.MarkerDirective = MarkerDirective;
    exports.PROVIDERS = PROVIDERS;
    exports.PolygonDirective = PolygonDirective;
    exports.PolylineDirective = PolylineDirective;
    exports.RectangleDirective = RectangleDirective;
    exports.ScriptProtocol = ScriptProtocol;
    exports.TrafficLayerDirective = TrafficLayerDirective;
    exports.TransitLayerDirective = TransitLayerDirective;
    exports.WindowRef = WindowRef;
    exports.mapsComponents = mapsComponents;
    exports.ɵa = BicyclingLayerDirective;
    exports.ɵb = MapService;
    exports.ɵc = MapsAPILoader;
    exports.ɵd = CircleDirective;
    exports.ɵe = EventService;
    exports.ɵf = FitBoundsDirective;
    exports.ɵg = FitBoundsAccessor;
    exports.ɵh = FitBoundsService;
    exports.ɵi = GroundOverlayDirective;
    exports.ɵj = KmlLayerDirective;
    exports.ɵk = MarkerDirective;
    exports.ɵl = MapComponent;
    exports.ɵm = PROVIDERS;
    exports.ɵn = PolygonDirective;
    exports.ɵo = PolylineDirective;
    exports.ɵp = RectangleDirective;
    exports.ɵq = TrafficLayerDirective;
    exports.ɵr = TransitLayerDirective;
    exports.ɵs = BROWSER_PROVIDERS;
    exports.ɵt = WindowRef;
    exports.ɵu = DocumentRef;
    exports.ɵv = LazyMapsAPILoader;
    exports.ɵw = API_CONFIG;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=dxgm-maps.umd.js.map
