/// <reference types="googlemaps" />
import { AfterContentInit, ElementRef, OnChanges, OnDestroy, SimpleChanges } from '@angular/core';
import { Observable, Subject } from 'rxjs';
import { EventService } from '../../services/event.service';
import { FitBoundsService } from '../../services/fitbounds.service';
import { MapService } from '../../services/map.service';
export declare class MapComponent implements AfterContentInit, OnChanges, OnDestroy {
    private _element;
    readonly mapService: MapService;
    private _eventService;
    protected _fitBoundsService: FitBoundsService;
    /**
     * See https://developers.google.com/maps/documentation/javascript/reference/map#MapOptions.center
     */
    center: google.maps.LatLngLiteral | google.maps.LatLng;
    /**
     * See https://developers.google.com/maps/documentation/javascript/reference/map#MapOptions.mapTypeId
     */
    mapTypeId: google.maps.MapTypeId;
    /**
     * See https://developers.google.com/maps/documentation/javascript/reference/map#MapOptions.zoom
     */
    zoom: number;
    /**
     * See https://developers.google.com/maps/documentation/javascript/reference/map#MapOptions
     */
    options: google.maps.MapOptions;
    /**
     * See https://developers.google.com/maps/documentation/javascript/reference/map#Map.bounds_changed
     */
    boundsChanged: Observable<void>;
    /**
     * See https://developers.google.com/maps/documentation/javascript/reference/map#Map.center_changed
     */
    centerChanged: Observable<void>;
    /**
     * See https://developers.google.com/maps/documentation/javascript/reference/map#Map.click
     */
    mapClick: Observable<google.maps.MapMouseEvent | google.maps.IconMouseEvent>;
    /**
     * See https://developers.google.com/maps/documentation/javascript/reference/map#Map.dblclick
     */
    mapDblclick: Observable<google.maps.MapMouseEvent>;
    /**
     * See https://developers.google.com/maps/documentation/javascript/reference/map#Map.drag
     */
    mapDrag: Observable<void>;
    /**
     * See https://developers.google.com/maps/documentation/javascript/reference/map#Map.drag
     */
    mapDragend: Observable<void>;
    /**
     * See https://developers.google.com/maps/documentation/javascript/reference/map#Map.drag
     */
    /**
     * See https://developers.google.com/maps/documentation/javascript/reference/map#Map.dragstart
     */
    mapDragstart: Observable<void>;
    /**
     * See https://developers.google.com/maps/documentation/javascript/reference/map#Map.heading_changed
     */
    headingChanged: Observable<void>;
    /**
     * See https://developers.google.com/maps/documentation/javascript/reference/map#Map.idle
     */
    idle: Observable<void>;
    /**
     * See https://developers.google.com/maps/documentation/javascript/reference/map#Map.maptypeid_changed
     */
    maptypeidChanged: Observable<void>;
    /**
     * See https://developers.google.com/maps/documentation/javascript/reference/map#Map.mousemove
     */
    mapMousemove: Observable<google.maps.MapMouseEvent>;
    /**
     * See https://developers.google.com/maps/documentation/javascript/reference/map#Map.mouseout
     */
    mapMouseout: Observable<google.maps.MapMouseEvent>;
    /**
     * See https://developers.google.com/maps/documentation/javascript/reference/map#Map.mouseover
     */
    mapMouseover: Observable<google.maps.MapMouseEvent>;
    /**
     * See https://developers.google.com/maps/documentation/javascript/reference/map#Map.projection_changed
     */
    projectionChanged: Observable<void>;
    /**
     * See https://developers.google.com/maps/documentation/javascript/reference/map#Map.rightclick
     */
    mapRightclick: Observable<google.maps.MapMouseEvent>;
    /**
     * See https://developers.google.com/maps/documentation/javascript/reference/map#Map.tilesloaded
     */
    tilesloaded: Observable<void>;
    /**
     * See https://developers.google.com/maps/documentation/javascript/reference/map#Map.tilt_changed
     */
    tiltChanged: Observable<void>;
    /**
     * See https://developers.google.com/maps/documentation/javascript/reference/map#Map.zoom_changed
     */
    zoomChanged: Observable<void>;
    mapReady: Subject<boolean>;
    /**
     * The underlying google.maps.Map object
     *
     * See https://developers.google.com/maps/documentation/javascript/reference/map#Map
     */
    map: google.maps.Map;
    private _isBrowser;
    private readonly _destroy$;
    constructor(platformId: Object, _element: ElementRef<Element>, mapService: MapService, _eventService: EventService, _fitBoundsService: FitBoundsService);
    ngAfterContentInit(): void;
    ngOnChanges(changes: SimpleChanges): void;
    ngOnDestroy(): void;
    private _onInit;
    private _combineOptions;
    private _getHTMLElement;
    private _assertInitialized;
}
