/// <reference types="googlemaps" />
import { OnDestroy, OnInit } from '@angular/core';
import { MapService } from '../../services/map.service';
/**
 * Angular directive that renders a Google Maps Bicycling Layer via the Google Maps JavaScript API.
 *
 * See https://developers.google.com/maps/documentation/javascript/reference/map#BicyclingLayer
 */
export declare class BicyclingLayerDirective implements OnInit, OnDestroy {
    private readonly _mapService;
    /**
     * The underlying google.maps.BicyclingLayer object
     *
     * See https://developers.google.com/maps/documentation/javascript/reference/map#BicyclingLayer
     */
    bicyclingLayer?: google.maps.BicyclingLayer;
    private readonly _destroy$;
    constructor(_mapService: MapService);
    ngOnInit(): void;
    ngOnDestroy(): void;
    private _onInit;
    private _assertInitialized;
}
