/// <reference types="googlemaps" />
import { NgZone, OnChanges, OnDestroy, OnInit, SimpleChanges } from '@angular/core';
import { MapService } from '../../services/map.service';
/**
 * Angular directive that renders a Google Maps Traffic Layer via the Google Maps JavaScript API.
 *
 * See https://developers.google.com/maps/documentation/javascript/reference/map#TrafficLayer
 */
export declare class TrafficLayerDirective implements OnInit, OnChanges, OnDestroy {
    private readonly _mapService;
    private readonly _ngZone;
    /**
     * See https://developers.google.com/maps/documentation/javascript/reference/map#TrafficLayerOptions.autoRefresh
     */
    autoRefresh: boolean;
    /**
     * The underlying google.maps.TrafficLayer object
     *
     * See https://developers.google.com/maps/documentation/javascript/reference/map#TrafficLayer
     */
    trafficLayer?: google.maps.TrafficLayer;
    private readonly _destroy$;
    constructor(_mapService: MapService, _ngZone: NgZone);
    ngOnInit(): void;
    ngOnChanges(changes: SimpleChanges): void;
    ngOnDestroy(): void;
    private _onInit;
    private _combineOptions;
    private _assertInitialized;
}
