/// <reference types="googlemaps" />
import { OnDestroy, OnInit } from '@angular/core';
import { MapService } from '../../services/map.service';
/**
 * Angular directive that renders a Google Maps Traffic Layer via the Google Maps JavaScript API.
 *
 * See https://developers.google.com/maps/documentation/javascript/reference/map#TransitLayer
 */
export declare class TransitLayerDirective implements OnInit, OnDestroy {
    private readonly _mapService;
    /**
     * The underlying google.maps.TransitLayer object
     *
     * See https://developers.google.com/maps/documentation/javascript/reference/map#TransitLayer
     */
    transitLayer?: google.maps.TransitLayer;
    private readonly _destroy$;
    constructor(_mapService: MapService);
    ngOnInit(): void;
    ngOnDestroy(): void;
    private _onInit;
    private _assertInitialized;
}
