import { ScriptProtocol } from '../enums/script-protocol.enums';
export interface IAPILoaderConfig {
    /**
     * The Google Maps API Key.
     * See https://developers.google.com/maps/documentation/javascript/get-api-key
     */
    apiKey?: string;
    /**
     * The Google Maps client ID.
     * See https://developers.google.com/maps/documentation/javascript/get-api-key
     */
    clientId?: string;
    /**
     * The Google Maps channel name.
     * See https://developers.google.com/maps/premium/previous-licenses/clientside/quota
     */
    channel?: string;
    /**
     * The Google maps API version.
     * See https://developers.google.com/maps/documentation/javascript/versions
     */
    apiVersion?: string;
    /**
     * Host and Path used for the `<script>` tag
     */
    hostAndPath?: string;
    /**
     * Protocol used for the `<script>` tag
     */
    protocol?: ScriptProtocol;
    /**
     * The google maps libraries.
     * See https://developers.google.com/maps/documentation/javascript/libraries
     */
    libraries?: string[];
    /**
     * The default bias for the map behavior is US.
     * If you wish to alter your application to serve different map tiles or bias the
     * application, you can overwrite the default behavior (US) by defining a `region`.
     * See https://developers.google.com/maps/documentation/javascript/basics#Region
     */
    region?: string;
    /**
     * The Google Maps API uses the browser's preferred language when displaying
     * textual information. If you wish to overwrite this behavior and force the API
     * to use a given language, you can use this setting.
     * See https://developers.google.com/maps/documentation/javascript/basics#Language
     */
    language?: string;
}
