/// <reference types="googlemaps" />
import { BehaviorSubject, Observable, ReplaySubject } from 'rxjs';
import { MapsAPILoader } from './abstract/abstract-map-api-loader.service';
export declare class FitBoundsService {
    protected loader: MapsAPILoader;
    protected readonly bounds$: Observable<any>;
    protected readonly _boundsChangeSampleTime$: BehaviorSubject<number>;
    protected readonly _includeInBounds$: BehaviorSubject<Map<string, number[]>>;
    readonly _fitBoundsDetails$: ReplaySubject<any>;
    constructor(loader: MapsAPILoader);
    getFitBoundsDeta(): Observable<any>;
    addToBounds(position: number[]): void;
    removeFromBounds(position: number[]): void;
    createIdentifier(position: number[]): string;
    changeFitBoundsChangeSampleTime(timeMs: number): void;
    generateBounds(includeInBounds: Map<string, number[]>): google.maps.LatLngBounds;
    getBounds(): Observable<google.maps.LatLngBounds>;
    private _generateBounds;
}
