/// <reference types="googlemaps" />
import { NgZone } from '@angular/core';
import { BehaviorSubject, Observable } from 'rxjs';
import { MapsAPILoader } from './abstract/abstract-map-api-loader.service';
export declare class MapService {
    private _loader;
    private _zone;
    get container(): HTMLElement;
    load$: BehaviorSubject<boolean>;
    private _map;
    private _container;
    constructor(_loader: MapsAPILoader, _zone: NgZone);
    getMap(): google.maps.Map;
    createMap(htmlElement: HTMLElement, opts: google.maps.MapOptions): Observable<void>;
    fitBounds(bounds: google.maps.LatLngBounds): void;
    destroy(): void;
    getMinZoom(): number;
    getMaxZoom(): number;
    setMinZoom(zoom: number): void;
    setMaxZoom(zoom: number): void;
    setZoomIn(): void;
    setZoomOut(): void;
}
